#include    <stdio.h>
#include    <stdlib.h>
#include    <cdr.h>
#include    <snd.h>
#include    <mos.h>

#define TRUE    1
#define FALSE   0
#define ERR     (-1)

#define DSPX    200
#define DSPY    100
#define FRACOL  15
#define BAKCOL  8

extern void grainit(void);
extern void graend(void);
extern void fbox(int x1,int y1,int x2,int y2,int col,int bcol,int mode);
extern void wrtptn(char *ptn,int x,int y,int sx,int sy,int col,int bak);
extern void wrtstr(char *str,int x,int y,int font,int ccol,int bcol);
extern void wrtmos(int sw);

char    extptn[]={
    0x00, 0x02, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 
    0x75, 0x7B, 0x45, 0x53, 0x72, 0x53, 0x45, 0x53, 
    0x75, 0x53, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 
    0x00, 0x03, 0x00, 0x03, 0xFF, 0xFF, 0x7F, 0xFF };
char    stpptn[]={
    0x00, 0x02, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 
    0x00, 0x03, 0x07, 0xC3, 0x07, 0xC3, 0x07, 0xC3, 
    0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 
    0x00, 0x03, 0x00, 0x03, 0xFF, 0xFF, 0x7F, 0xFF };
char    bakptn[]={
    0x00, 0x02, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 
    0x02, 0x23, 0x06, 0x63, 0x0E, 0xE3, 0x1F, 0xE3, 
    0x0E, 0xE3, 0x06, 0x63, 0x02, 0x23, 0x00, 0x03, 
    0x00, 0x03, 0x00, 0x03, 0xFF, 0xFF, 0x7F, 0xFF };
char    plyptn[]={
    0x00, 0x02, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 
    0x02, 0x03, 0x03, 0x03, 0x03, 0x83, 0x03, 0xC3, 
    0x03, 0x83, 0x03, 0x03, 0x02, 0x03, 0x00, 0x03, 
    0x00, 0x03, 0x00, 0x03, 0xFF, 0xFF, 0x7F, 0xFF };
char    nxtptn[]={
    0x00, 0x02, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 
    0x08, 0x83, 0x0C, 0xC3, 0x0E, 0xE3, 0x0F, 0xF3, 
    0x0E, 0xE3, 0x0C, 0xC3, 0x08, 0x83, 0x00, 0x03, 
    0x00, 0x03, 0x00, 0x03, 0xFF, 0xFF, 0x7F, 0xFF };

typedef struct {
    char    min;
    char    sec;
    char    frame;
} CDTIME;

typedef struct {
    int     sw_no;
    int     sw_x, sw_y;
    char    *sw_pttn;
} SWP;

int     type=0,strt=0,endt=0;
int     vol=0,sts=0,no=0,acv=0,mos=ERR;
CDTIME  st,ed;
CDTIME  *track=NULL;
SWP     swp[]={ {0,10,44,extptn},
                {2,40,44,stpptn}, {3,70,44,bakptn},
                {4,100,44,plyptn}, {5,130,44,nxtptn},
                {0,0,0,NULL} };

int     CD_open(void)
{
    int     i;
    CDTIME  disc;

    if ( track != NULL && acv != 0 )
        return 0;

    if ( track == NULL && 
        (track = (CDTIME *)malloc(sizeof(CDTIME)*99)) == NULL )
        return 1;

    do {
        i = cdr_cdinfo(0,&type,&strt,&endt,(char *)track,(char *)&disc);
    } while ( i == CDERR7 );

    if ( disc.frame-- <= 0 ) {
    disc.frame = 74;
    if ( disc.sec-- <= 0 ) {
        disc.sec = 59;
        if ( disc.min-- <= 0 )
        return 1;
    }
    }

    track[endt].min = disc.min;
    track[endt].sec = disc.sec;
    track[endt].frame = disc.frame;

    if ( i == 0 ) acv = 1;
    return i;
}
void    CD_play(void)
{
    int     i;

    if ( cdr_mphase(0,&sts,&no,(char *)&st,(char *)&ed) != 0 )
        return;
    if ( sts != 0 )
        return;
    wrtmos(1);
    if ( CD_open() != 0 ) return;
    if ( endt > 0 ) {
        for ( i=0 ; i < endt && (track[i].min & 0x80) != 0 ; i++ );
        no = cdr_mtplay(0,(char *)&(track[i]),(char *)&(track[endt]));
    }
    wrtmos(mos = 2);
}
void    CD_next(void)
{
    int     i;

    if ( cdr_mphase(0,&sts,&no,(char *)&st,(char *)&ed) != 0 )
        return;
    if ( sts != 0 )
        cdr_pause(0);
    else
        no = 0;
    wrtmos(1);
    if ( CD_open() != 0 ) return;
    if ( endt > 0 ) {
        if ( no >= endt ) no = 0;
        for ( i=no ; i < endt && (track[i].min & 0x80) != 0 ; i++ );
        cdr_mtplay(0,(char *)&(track[i]),(char *)&(track[endt]));
    }
    wrtmos(mos = 2);
}
void    CD_back(void)
{
    int     i;

    if ( cdr_mphase(0,&sts,&no,(char *)&st,(char *)&ed) != 0 )
        return;
    if ( sts != 0 )
        cdr_pause(0);
    else
        no = 0;
    wrtmos(1);
    if ( CD_open() != 0 ) return;
    if ( endt > 0 ) {
        if ( --no <= 0 ) no = endt;
        for ( i=no-1 ; i < endt && (track[i].min & 0x80) != 0 ; i++ );
        cdr_mtplay(0,(char *)&(track[i]),(char *)&(track[endt]));
    }
    wrtmos(mos = 2);
}
void    main(void)
{
    int     i,j,max;
    int     b,x,y,lev;
    int     old,dp,wait;
    CDTIME  ot;
    char    tmp[8];

    SND_elevol_read(1,&vol,&vol);
    grainit();
    SND_elevol_init();
    SND_elevol_mute(0x30);
    SND_elevol_set(1,vol,vol);

    fbox(DSPX,DSPY,DSPX+154,DSPY+90,FRACOL,BAKCOL,0);
    fbox(DSPX+2,DSPY+2,DSPX+152,DSPY+13,7,7,0);
    wrtstr("CD PLAYER",DSPX+42,DSPY+4,1,1,7);
    fbox(DSPX+8,DSPY+20,DSPX+58,DSPY+32,FRACOL,0,0);
    fbox(DSPX+68,DSPY+20,DSPX+88,DSPY+32,FRACOL,0,0);
    fbox(DSPX+98,DSPY+20,DSPX+142,DSPY+32,FRACOL,0,0);
    fbox(DSPX+10,DSPY+70,DSPX+143,DSPY+82,FRACOL,0,0);
    fbox(DSPX+12,DSPY+72,DSPX+12+vol,DSPY+80,7,7,0);
    fbox(DSPX+12+vol,DSPY+72,DSPX+14+vol,DSPY+80,10,0,0);
    for ( max=0 ; swp[max].sw_pttn != NULL ; max++ ) {
        wrtptn(swp[max].sw_pttn,
               DSPX + swp[max].sw_x, DSPY + swp[max].sw_y,
               16,16,0,BAKCOL);
    }

    for ( wait = lev = dp = 0,old = (-5),ot.sec = ERR ; ; ) {
        if ( cdr_mphase(0,&sts,&no,(char *)&st,(char *)&ed) != 0 ) {
            sts = no = ERR;
            dp = st.sec = st.min = 0;
        } else if ( sts == 0 )
            no = dp = st.sec = st.min = 0;
        if ( old != no ) {
            if ( old > 0 )
                fbox(DSPX+8,DSPY+20,DSPX+58,DSPY+32,FRACOL,0,0);
            if ( no < 0 )
                strcpy(tmp,"**");
            else 
                sprintf(tmp,"%02d",no);     
            wrtstr(tmp,DSPX + 70,DSPY + 23,1,10,0);
            old = no;
            if ( old > 0 && acv != 0 && endt > 0 ) {
                dp = DSPX + 10 + (46 * (old - 1) ) / endt;
                fbox(dp,DSPY+22,dp+3,DSPY+30,10,10,0);
            } else
                dp = 0;
        }
        if ( ot.min != st.min || ot.sec != st.sec ) {
            sprintf(tmp,"%02d:%02d",st.min,st.sec);
            wrtstr(tmp,DSPX + 100,DSPY + 23,1,10,0);
            ot.min = st.min;
            ot.sec = st.sec;
        }
        if ( acv != 0 && sts <= 0 ) {
            cdr_mstop(0);
            acv = 0;
        }

        if ( sts > 0 ) {
            if ( mos < 0 )
                wrtmos(mos = 2);
            else if ( mos >= 2 && ++wait > 6 ) {
                if ( ++mos > 5 ) mos = 2;
                wrtmos(mos);
                wait = 0;
            }
        } else if ( mos != 0 )
            wrtmos(mos = 0);

        if ( (i = SND_elevol_led_read()) != lev ) {
            if ( i < lev )
                fbox(DSPX+12+i*16,DSPY+74,DSPX+12+(lev*16 > vol ? vol:lev*16),
                     DSPY+78,7,7,0);
            else
                fbox(DSPX+12,DSPY+74,DSPX+12+i*16,DSPY+78,2,2,0);
            lev = i;
        }

        MOS_rdpos(&b,&x,&y);
        if ( b != 0 ) {
            for ( i = 0 ; i < max ; i++ ) {
                if ( x >= (DSPX + swp[i].sw_x ) && 
                     x <= (DSPX + swp[i].sw_x + 15) &&
                     y >= (DSPY + swp[i].sw_y ) && 
                     y <= (DSPY + swp[i].sw_y + 15) )
                    break;
            }
            if ( i < max ) {
                fbox( DSPX + swp[i].sw_x, DSPY + swp[i].sw_y,
                      DSPX + swp[i].sw_x + 13, DSPY + swp[i].sw_y + 13,
                      15,15,4);
                j = swp[i].sw_no;
                if ( j == 0 )       /* EXIT */
                    break;
                else if ( j == 2 )
                    cdr_mstop(0);
                else if ( j == 3 )
                    CD_back();
                else if ( j == 4 )
                    CD_play();
                else if ( j == 5 )
                    CD_next();
                fbox( DSPX + swp[i].sw_x, DSPY + swp[i].sw_y,
                      DSPX + swp[i].sw_x + 13, DSPY + swp[i].sw_y + 13,
                      15,15,4);
            } else if ( x >= (DSPX+10) && x <= (DSPX+142) &&
                        y >= (DSPY+70) && y <= (DSPY+82) ) {
                j = x - (DSPX + 12);
                if ( j < 0 ) j = 0;
                if ( j > 127 ) j = 127;
                if ( j != vol ) {
                    if ( j < vol )
                        fbox(DSPX+12+j,DSPY+72,DSPX+142,DSPY+80,0,0,0);
                    else
                        fbox(DSPX+12,DSPY+72,DSPX+12+j,DSPY+80,7,7,0);
                    fbox(DSPX+12+j,DSPY+72,DSPX+14+j,DSPY+80,10,0,0);
                    vol = j;
                    SND_elevol_set(1,vol,vol);
                }
            }
        }
    }
    graend();
}
