/*
 *	display.c
 */

#include	<stdlib.h>
#include	<string.h>
#include	<egb.h>
#include	<mos.h>
#include	<msdos.cf>
#include	"display.h"


#define		GLOBAL


/*--------------------------------------*/
/*		萔`		*/
/*--------------------------------------*/

#define		EgbWkSize	1536
#define		MosWkSize	4096


/*--------------------------------------*/
/*		ϐ`		*/
/*--------------------------------------*/

char	_EgbWk[EgbWkSize];		/* EGBpƈ			*/
char	_EgbPara[256];			/* EGB p^p[N	*/
char	_MosWk[MosWkSize];		/* }EXpƈ		*/

int	_DISP_palette[16];		/* \tgEFAJ[pbg	*/
int 	_ScrnModePage[4];		/* Jgʃ[hۑ	*/
clutDataBlock_t		_Clut;		/* Jgn[hLUTۑ	*/


/*--------------------------------------*/
/*		[J֐錾	*/
/*--------------------------------------*/

/*	[J֐͖	*/


/*--------------------------------------*/
/*		֐`		*/
/*--------------------------------------*/

GLOBAL	void
DISP_init(void)
/*
 *	PURPOSE
 *		ʂƃ}EX̏sD
 *			y[W0 : 320~240 32KF 2{g
 *			y[W1 : 640~480 16F
 *		y[W1OʂɂāCy[W\D
 *		̏݃y[W̓y[W1ƂȂD
 *		}EX̕\y[W̓y[W1ƂȂD
 */
{
	EGB_init(_EgbWk, EgbWkSize);
	DISP_setScrnMode(Page0, 10);
	DISP_setScrnMode(Page1, 3);
	EGB_displayPage(_EgbWk, Page1, 3);	/* Page1OCPage0/1\ */
	EGB_writePage(_EgbWk, Page0);
	EGB_displayStart(_EgbWk, 2, 2, 2);	/* ʂ̊g: X=2{, Y=2{ */
	EGB_displayStart(_EgbWk, 3, 
		Mode10VirScrnX, Mode10VirScrnY);	/* \ʂ̊g */
	EGB_writePage(_EgbWk, Page1);
	
	MOS_start(_MosWk, MosWkSize);
	MOS_resolution(Page0, 10);
	MOS_resolution(Page1, 3);
	MOS_writePage(Page1);
	
	DISP_setPalette(DISP_PalReset);
}
/* ---	DISP_init()  --- */


GLOBAL	void
DISP_terminate(
	int	consoleMode)	/* R\[ʃ[hݒtO */
/*
 *	PURPOSE
 *		ʂ̕\IsD
 *		consoleMode0ȊOł΁C
 *		R\[ʃ[h(640~400 16F)ɐݒ肷D
 *		consoleMode0ł΁Cʃ[h͕ύXȂD
 */
{
	MOS_end();
	
	if (consoleMode) {
		EGB_init(_EgbWk, EgbWkSize);
		EGB_resolution(_EgbWk, Page0, 1);	/* y[W0:[h1 */
		EGB_resolution(_EgbWk, Page1, 1);	/* y[W1:[h1 */
		EGB_writePage(_EgbWk, Page0);
		EGB_displayPage(_EgbWk, 0, 3);		/* y[W0O */
		DISP_initClut16();
		EGB_writePage(_EgbWk, Page1);
	}
}
/* ---	DISP_terminate()  --- */


GLOBAL	void
DISP_setScrnMode(
	int	page,		/* ݒΏۃy[W */
	int	mode)		/* ʃ[hԍ */
/*
 *	PURPOSE
 *		ʃ[hݒ肷D
 */
{
	EGB_resolution(_EgbWk, page, mode);
	_ScrnModePage[page] = mode;
}
/* ---	DISP_setScrnMode()  --- */


GLOBAL	long
DISP_getScrnMode(void)
/*
 *	PURPOSE
 *		ݐݒ肳Ăʃ[hʒmD
 *	RETURNS
 *		bit31...bit24	: y[W3
 *		bit23...bit16	: y[W2
 *		bit15...bit8	: y[W1
 *		bit7 ...bit0	: y[W0
 *		y[W01ʃ[h̏ꍇCy[W1`y[W3͖D
 */
{
	int	page;
	long	mode = 0;
	
	for (page = 3; page >= 0; page--) {
		mode <<= 8;
		mode |= _ScrnModePage[page];
	}
	return(mode);
}
/* ---	DISP_getScrnMode()  --- */


GLOBAL	void
DISP_clearScreen(
	int	colorIGRB)	/* ʂF(IGRBl) */
/*
 *	PURPOSE
 *		\ʂw肳ꂽFŏD
 */
{
	EGB_colorIGRB(_EgbWk, 1, colorIGRB);	/* wiFݒ */
	EGB_writeMode(_EgbWk, 0);		/* PSET */
	EGB_clearScreen(_EgbWk);
}
/* ---	DISP_clearScreen()  --- */


GLOBAL	void
DISP_setClut(
	char	*clutData)	/* EGB_palette()̑Rw */
/*
 *	PURPOSE
 *		ݑIĂy[W̃n[hEFAJ[LUT
 *		VSYNC҂ĕύXD
 */
{
	int	entries, i;
	int	ci;
	
	/*
	 * w肳ꂽJ[LUTۑD
	 */
	entries = ((clutDataBlock_t *)clutData)->cnt;
	for (i = 0; i < entries; i++) {
		ci = ((clutDataBlock_t *)clutData)->clutEntry[i].ci;
		_Clut.clutEntry[ci].ci = ci;
		_Clut.clutEntry[ci].blue = 
			((clutDataBlock_t *)clutData)->clutEntry[i].blue;
		_Clut.clutEntry[ci].red = 
			((clutDataBlock_t *)clutData)->clutEntry[i].red;
		_Clut.clutEntry[ci].green = 
			((clutDataBlock_t *)clutData)->clutEntry[i].green;
		_Clut.clutEntry[ci].rsv	= 
			((clutDataBlock_t *)clutData)->clutEntry[i].rsv;
	}
	EGB_palette(_EgbWk, 1, clutData);	/* VSYNC҂ĕύX */
}
/* ---	DISP_setClut()  --- */


GLOBAL	void
DISP_getClut(
	int	top,		/* ʒm擪Ggԍ */
	int	entries,	/* ʒmGg */
	char	*clutData)	/* ʒm̈ւ̃|C^ */
/*
 *	PURPOSE
 *		݂̃J[e[ûCtopentries
 *		clutDataŎw肳ꂽ̈֒ʒmD
 */
{
	int	i;
	
	((clutDataBlock_t *)clutData) -> cnt = entries;
	for (i = 0; i < entries; i++) {
		((clutDataBlock_t *)clutData) -> clutEntry[i].ci = 
			_Clut.clutEntry[top + i].ci;
		((clutDataBlock_t *)clutData) -> clutEntry[i].blue = 
			_Clut.clutEntry[top + i].blue;
		((clutDataBlock_t *)clutData) -> clutEntry[i].red = 
			_Clut.clutEntry[top + i].red;
		((clutDataBlock_t *)clutData) -> clutEntry[i].green = 
			_Clut.clutEntry[top + i].green;
		((clutDataBlock_t *)clutData) -> clutEntry[i].rsv = 
			_Clut.clutEntry[top + i].rsv;
	}
}
/* ---	DISP_getClut()  --- */


GLOBAL	void
DISP_initClut16(void)
/*
 *	PURPOSE
 *		݂̏݃y[W̃n[hEFA16FJ[LUTD
 */
{
	static	clutDataBlock_t	_clutInit16 = {
		16,
		/* Blue, Red, Green */
		0, 0x00, 0x00, 0x00, 0,
		1, 0x7f, 0x00, 0x00, 0,
		2, 0x00, 0x7f, 0x00, 0,
		3, 0x7f, 0x7f, 0x00, 0,
		4, 0x00, 0x00, 0x7f, 0,
		5, 0x7f, 0x00, 0x7f, 0,
		6, 0x00, 0x7f, 0x7f, 0,
		7, 0x7f, 0x7f, 0x7f, 0,
		8, 0x3f, 0x3f, 0x3f, 0,
		9, 0xff, 0x00, 0x00, 0,
		10,0x00, 0xff, 0x00, 0,
		11,0xff, 0xff, 0x00, 0,
		12,0x00, 0x00, 0xff, 0,
		13,0xff, 0x00, 0xff, 0,
		14,0x00, 0xff, 0xff, 0,
		15,0xff, 0xff, 0xff, 0
	};
	
	DISP_setClut((char *)&_clutInit16);
}
/* ---	DISP_initClut16()  --- */


GLOBAL	void
DISP_initClut256(void)
/*
 *	PURPOSE
 *		݂̏݃y[W̃n[hEFA256FJ[LUTD
 */
{
	clutDataBlock_t	clut;
	int		i;
	
	clut.cnt	= ClutEntries;
	for (i = 0; i < ClutEntries; i++) {
		clut.clutEntry[i].ci	= i;
		clut.clutEntry[i].blue	= 
			((i & 0x03) << 6) | ((i & 0x03) ? 0x3f : 0);
		clut.clutEntry[i].red	= 
			((i & 0x1c) << 3) | ((i & 0x1c) ? 0x1f : 0);
		clut.clutEntry[i].green	= 
			(i & 0xe0) | ((i & 0xe0) ? 0x1f : 0);
		clut.clutEntry[i].rsv	= 0;
	}
	DISP_setClut((char *)&clut);
}
/* ---	DISP_initClut256()  --- */


GLOBAL	void
DISP_setPalette(
	int	type)		/* 0:11, 1:32KF, 2:256F, 3:16F */
/*
 *	PURPOSE
 *		\tgEFApbgw肳ꂽԂɕύXD
 *		J[LUTԂł΁CCI_xxxxɂwFD
 */
{
	int	i;
	int	color;
	
	switch (type) {
	case DISP_PalReset:			/* n[hLUT11ɑΉ */
		for (i = 0; i < 16; i++)
			_DISP_palette[i] = i;
		break;
	
	case DISP_PalColor32k:			/* 32kFp */
		_DISP_palette[0] = IGRB(0, 0, 0, 0);
		_DISP_palette[1] = IGRB(0, 0, 0, 0x7f);
		_DISP_palette[2] = IGRB(0, 0, 0x7f, 0);
		_DISP_palette[3] = IGRB(0, 0, 0x7f, 0x7f);
		_DISP_palette[4] = IGRB(0, 0x7f, 0, 0);
		_DISP_palette[5] = IGRB(0, 0x7f, 0, 0x7f);
		_DISP_palette[6] = IGRB(0, 0x7f, 0x7f, 0);
		_DISP_palette[7] = IGRB(0, 0x7f, 0x7f, 0x7f);
		_DISP_palette[8] = IGRB(0, 0x3f, 0x3f, 0x3f);
		_DISP_palette[9] = IGRB(0, 0, 0, 0xff);
		_DISP_palette[10] = IGRB(0, 0, 0xff, 0);
		_DISP_palette[11] = IGRB(0, 0, 0xff, 0xff);
		_DISP_palette[12] = IGRB(0, 0xff, 0, 0);
		_DISP_palette[13] = IGRB(0, 0xff, 0, 0xff);
		_DISP_palette[14] = IGRB(0, 0xff, 0xff, 0);
		_DISP_palette[15] = IGRB(0, 0xff, 0xff, 0xff);
		break;
	
	case DISP_PalColor256:			/* 256Fp */
		for (i = 0; i < 16; i++) {
			color = (i & 0x01) ? ((i & 0x08) ? 0x03 : 0x01) : 0;
			color |= (i & 0x02) ? ((i & 0x08) ? 0x1c : 0x0c) : 0;
			color |= (i & 0x04) ? ((i & 0x08) ? 0xe0 : 0x60) : 0;
			_DISP_palette[i] = color;
		}
		break;
	
	case DISP_PalColor16:			/* 16Fp */
		for (i = 0; i < 16; i++)
			_DISP_palette[i] = i;
		break;
	}
}
/* ---	DISP_setPalette()  --- */


GLOBAL	void
DISP_getPixelBlock(
	int		luX,
	int		luY,
	int		rdX,
	int		rdY,
	char		*buffer)	/* \Ώۃf[^ */
/*
 *	PURPOSE
 *		W(x1,y1)(x2,y2)܂ł̃sNZf[^
 *		buffer֎oD
 */
{
	DWORD(_EgbPara + 0) = (unsigned int)buffer;
	WORD(_EgbPara + 4) = getds();
	WORD(_EgbPara + 6) = luX;
	WORD(_EgbPara + 8) = luY;
	WORD(_EgbPara + 10) = rdX;
	WORD(_EgbPara + 12) = rdY;
	EGB_getBlock(_EgbWk, _EgbPara);
}
/* ---	DISP_getPixelBlock()  --- */


GLOBAL	void
DISP_putPixelBlock(
	int		luX,
	int		luY,
	int		rdX,
	int		rdY,
	char		*buffer)	/* \Ώۃf[^ */
/*
 *	PURPOSE
 *		buffer̃sNZf[^
 *		W(x1,y1)(x2,y2)܂łɕ\D
 */
{
	DWORD(_EgbPara + 0) = (unsigned int)buffer;
	WORD(_EgbPara + 4) = getds();
	WORD(_EgbPara + 6) = luX;
	WORD(_EgbPara + 8) = luY;
	WORD(_EgbPara + 10) = rdX;
	WORD(_EgbPara + 12) = rdY;
	EGB_putBlock(_EgbWk, 0, _EgbPara);
}
/* ---	DISP_putPixelBlock()  --- */


GLOBAL	void
DISP_putBlock(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	char	*buffer,
	int	colorIx)
/*
 *	PURPOSE
 *		1rbg^sNZ̃mNf[^wFŕ\D
 */
{
	EGB_color(_EgbWk, 0, colorIx);
	
	DWORD(_EgbPara + 0) = (unsigned int)buffer;
	WORD(_EgbPara + 4) = getds();
	WORD(_EgbPara + 6) = luX;
	WORD(_EgbPara + 8) = luY;
	WORD(_EgbPara + 10) = rdX;
	WORD(_EgbPara + 12) = rdY;
	EGB_putBlockColor(_EgbWk, 0, _EgbPara);
}
/* ---	DISP_putBlock()  --- */


GLOBAL	void
DISP_line(
	int	x1,			/* Jn_ */
	int	y1,
	int	x2,			/* I_ */
	int	y2,
	int	colorIndex)
/*
 *	PURPOSE
 *		wW1{̐`D
 */
{
	EGB_color(_EgbWk, 0, colorIndex);	/* Fݒ */
	
	WORD(_EgbPara + 0) = 2;			/* W_ = 2 */
	WORD(_EgbPara + 2) = x1;
	WORD(_EgbPara + 4) = y1;
	WORD(_EgbPara + 6) = x2;
	WORD(_EgbPara + 8) = y2;
	EGB_connect(_EgbWk, _EgbPara);		/* ` */
}
/* ---	DISP_line()  --- */


GLOBAL	void
DISP_xorLine(
	int	x1,			/* Jn_ */
	int	y1,
	int	x2,			/* I_ */
	int	y2,
	int	colorIndex)
/*
 *	PURPOSE
 *		wWԐXOR[hŕ`D
 */
{
	EGB_writeMode(_EgbWk, 4);		/* XOR [hݒ */
	EGB_color(_EgbWk, 0, colorIndex);	/* Fݒ */
	
	WORD(_EgbPara + 0) = 2;			/* W_ = 2 */
	WORD(_EgbPara + 2) = x1;
	WORD(_EgbPara + 4) = y1;
	WORD(_EgbPara + 6) = x2;
	WORD(_EgbPara + 8) = y2;
	EGB_connect(_EgbWk, _EgbPara);		/* ` */
	
	EGB_writeMode(_EgbWk, 0);		/* PSET [hɖ߂ */
}
/* ---	DISP_xorLine()  --- */


GLOBAL	void
DISP_rectangle(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex)
/*
 *	PURPOSE
 *		w肵ʒuɎwF̖ʓh蒷`\D
 */
{
	/* g̓h */
	
	EGB_paintMode(_EgbWk, 0x022);		/* ʓh:x^, E:x^ */
	EGB_color(_EgbWk, 0, colorIndex);	/* EFݒ */
	EGB_color(_EgbWk, 2, colorIndex);	/* ʓhFݒ */
	WORD(_EgbPara + 0) = luX;
	WORD(_EgbPara + 2) = luY;
	WORD(_EgbPara + 4) = rdX;
	WORD(_EgbPara + 6) = rdY;
	EGB_rectangle(_EgbWk, _EgbPara);
}
/* ---	DISP_rectangle()  --- */


GLOBAL	void
DISP_xorRectangle(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex)
/*
 *	PURPOSE
 *		w肵ʒuɎwF̖ʓh蒷`XOR[hŕ\D
 */
{
	EGB_writeMode(_EgbWk, 4);		/* XOR [hݒ */
	
	/* g̓h */
	
	EGB_paintMode(_EgbWk, 0x022);		/* ʓh:x^, E:x^ */
	EGB_color(_EgbWk, 0, colorIndex);	/* EFݒ */
	EGB_color(_EgbWk, 2, colorIndex);	/* ʓhFݒ */
	WORD(_EgbPara + 0) = luX;
	WORD(_EgbPara + 2) = luY;
	WORD(_EgbPara + 4) = rdX;
	WORD(_EgbPara + 6) = rdY;
	EGB_rectangle(_EgbWk, _EgbPara);
	
	EGB_writeMode(_EgbWk, 0);		/* PSET [hɖ߂ */
}
/* ---	DISP_xorRectangle()  --- */


GLOBAL	void
DISP_rectBox(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex)
/*
 *	PURPOSE
 *		w肵ʒuɎwF̒`̘g\D
 */
{
	/* g̊O` */
	
	EGB_paintMode(_EgbWk, 0x002);		/* ʓh:, E:x^ */
	EGB_color(_EgbWk, 0, colorIndex);	/* EFݒ */
	WORD(_EgbPara + 0) = luX;
	WORD(_EgbPara + 2) = luY;
	WORD(_EgbPara + 4) = rdX;
	WORD(_EgbPara + 6) = rdY;
	EGB_rectangle(_EgbWk, _EgbPara);
}
/* ---	DISP_rectBox()  --- */


GLOBAL	void
DISP_xorRectBox(
	int	luX,
	int	luY,
	int	rdX,
	int	rdY,
	int	colorIndex)
/*
 *	PURPOSE
 *		w肵ʒuɎwF̒`̘gXOR[hŕ\D
 */
{
	EGB_writeMode(_EgbWk, 4);		/* XOR [hݒ */
	
	/* g̊O` */
	
	EGB_paintMode(_EgbWk, 0x002);		/* ʓh:, E:x^ */
	EGB_color(_EgbWk, 0, colorIndex);	/* EFݒ */
	WORD(_EgbPara + 0) = luX;
	WORD(_EgbPara + 2) = luY;
	WORD(_EgbPara + 4) = rdX;
	WORD(_EgbPara + 6) = rdY;
	EGB_rectangle(_EgbWk, _EgbPara);
	
	EGB_writeMode(_EgbWk, 0);		/* PSET [hɖ߂ */
}
/* ---	DISP_xorRectBox()  --- */


GLOBAL	void
DISP_stringAt(
	char	*string,
	int	x,
	int	y,
	int	colorIndex)
/*
 *	PURPOSE
 *		w肵ʒuɎwF̕\D
 */
{
	int	l;
	
	EGB_color(_EgbWk, 0, colorIndex);		/* Fݒ */
	
	WORD(_EgbPara + 0) = x;
	WORD(_EgbPara + 2) = y;
	WORD(_EgbPara + 4) = l = strlen(string);
	strcpy(&_EgbPara[6], string);
	EGB_sjisString(_EgbWk, _EgbPara);
}
/* --- DISP_stringAt()  --- */


GLOBAL	void
DISP_stringRect(
	char	*string,
	int	foreColor,		/* Ƙg̐F */
	int	backColor)		/* ̔wiF */
/*
 *	PURPOSE
 *		o͗̈C
 *		w肵640~480hbg̉ʒɕ\
 *		́Cw肵F̘gň͂ށD
 */
{
	int	x, y;
	int	width, lx;
	
	x = Mode3RealScrnX / 2;	/* Mode3RealScrnX = ʉsNZ */
	y = Mode3RealScrnY / 2;	/* Mode3RealScrnY = ʏcsNZ */
	
	width = strlen(string) * 8 + 16;/* 8hbg/ANK,]2 */
	if ((lx = x - width / 2) < 0)
		lx = 0;
	lx &= ~1;			/* Wʒu */
	
	/* o͗̈ */
	
	DISP_rectangle(0, y - 16, Mode3RealScrnX - 1, y + 16 - 1, 0);
	
	/* g̓h */
	
	DISP_rectangle(lx, y - 16, lx + width - 1, y + 16 - 1, backColor);
	
	/*  */
	
	DISP_stringAt(string, lx + 8, y + 8, foreColor);
	
	/* g */
	
	DISP_rectBox(lx, y - 16, lx + width - 1, y + 16 - 1, foreColor);
}
/* ---	DISP_stringRect()  --- */


GLOBAL	void
DISP_setPage(
	int	page)
/*
 *	PURPOSE
 *		݃y[Wݒ肷D
 */
{
	EGB_writePage(_EgbWk, page);
}
/* ---	DISP_setPage()  --- */


GLOBAL	int
DISP_getPixel(
	int	x,
	int	y)
/*
 *	PURPOSE
 *		w_̃sNZlIGRB`ŒʒmD
 *	RETURNS
 *		IGRB`̃sNZl
 */
{
	int	colorIGRB;
	
	EGB_point(_EgbWk, 1, x, y, &colorIGRB);	/* IGRB`œǂ */
	return(colorIGRB);
}
/* ---	DISP_getPixel()  --- */


GLOBAL	void
DISP_setPixel(
	int	x,
	int	y,
	int	colorIGRB)
/*
 *	PURPOSE
 *		IGRB`̃sNZlw_ɐݒ肷D
 */
{
	EGB_colorIGRB(_EgbWk, 0, colorIGRB);	/* OiFݒ */
	
	WORD(_EgbPara + 0) = 1;			/* W_ = 1 */
	WORD(_EgbPara + 2) = x;
	WORD(_EgbPara + 4) = y;
	EGB_pset(_EgbWk, _EgbPara);
}
/* ---	DISP_setPixel()  --- */


/*****	display.c  *****/
