/*
 *	filedlg.c
 *		t@C_CAO\[`
 */

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<setjmp.h>
#include	"button.h"
#include	"display.h"
#include	"mouse.h"
#include	"msdos.h"
#include	"setup.h"
#include	"filedlg.h"

#define		GLOBAL
#define		LOCAL

#define		TRUE		1
#define		FALSE		0


/*--------------------------------------*/
/*		^`			*/
/*--------------------------------------*/

/*	Boolean^`		*/

typedef		int	Bool_t;

/*	t@C\̂̒`	*/

typedef	struct	fileInfo	{
	struct fileInfo	*next;		/* vf */
	struct fileInfo	*prev;		/* Ovf */
	char		name[13];
	char		attr;
	unsigned short	date;
	unsigned short	time;
	long		size;
	int		select;
}	fileInfo_t;


/*--------------------------------------*/
/*		萔`		*/
/*--------------------------------------*/

/* --------	t@C֘A	--------*/

#define		PathLen		80
#define		FnameLen	12
#define		DriveQ		17

/* --------	CxgID	--------*/

/*	CxgIDlong^łC
 *	short^majorCxgIDƁCshort^minorCxgIDȂD
 *	majorCxgID̓CxgʂC
 *	minorCxgID͊eCxg̏ڍׂʂD
 */

/*	majorIDminorIDo}N	*/
#define		major(id)	(id & 0xffff)
#define		minor(id)	((id >> 16) & 0xffff)

/*	majorCxgID		*/
#define		BtnDriveLeft	0
#define		BtnDriveCenter	1
#define		BtnDriveRight	2
#define		BtnParent	3
#define		BtnScrollUp	4
#define		BtnScrollDown	5
#define		BtnOk		6
#define		BtnCancel	7
#define		MaxButtons	8
#define		FileList	9

/* --------	G[R[h	--------*/

#define		NoAvailableMemory	1
#define		IllegalDirection	2

/* --------	ʊ֘A萔	--------*/
/*		Pʂ̓sNZ		*/

int	FD_CharWidth	= 8;		/* 1oCg̉hbg	*/
int	FD_CharHeight	= 16;		/* 1oCg̏chbg	*/

/* --------	ftHg_CAO{bNX	--------*/
/*
 *	ftHg_CAO{bNX̕\ʒu̒`
 *		{_CAO{bNX640~480sNZ̉ʂz肵ĂD
 */
int	FD_DialogPosX	= 240;		/* _CAO{bNXxW	*/
int	FD_DialogPosY	= 40;		/* _CAO{bNXyW	*/

int	FD_DriveBtnWidth = 32;
		/* hCu{^̃hbg				*/
		/* = strlen(FD_DriveName[0]) * FD_CharWidth + 8 * 2	*/
int	FD_ParentBtnWidth = 32;
		/* efBNg{^̃hbg			*/
		/* = strlen(FD_ParentBtnName) * FD_CharWidth + 8 * 2	*/
int	FD_ScrollBtnWidth = 32;
		/* XN[{^̃hbg				*/
		/* = strlen(FD_ScrollBtnName[0]) * FD_CharWidth + 8 * 2	*/
int	FD_OkNgBtnWidth = 48;
		/* mF^{^̃hbg				*/
		/* = strlen(FD_OkNgBtnName[0]) * FD_CharWidth + 8 * 2	*/
int	FD_ButtonHeight	= 32;
		/* {^̏chbg				*/
		/* = FD_CharHeight + 8 * 2				*/

int	FD_LeftMargin	= 8;		/* hCu{^܂ł̃ItZbg */
int	FD_TopMargin	= 8;		/* ^Cg܂ł̃ItZbg */
int	FD_RightMargin	= 8;		/* {^̃ItZbg	*/
int	FD_BottomMargin	= 8;		/*				*/

int	FD_FilesInList	= 10;	/* t@CXgɕ\t@C	*/

/* --------	_CAO{^̕\	--------*/
/*		ύXƁC{^̕ύX\ */

char	*FD_DriveName[] = {
	"@", "`", "a", "b", "c", "d", "e", "f", "g",
	"h", "i", "j", "k", "l", "m", "n", "o", "p"
};
char	*FD_ParentBtnName = "e";
char	*FD_ScrollBtnName[] = {"", ""};
char	*FD_OkNgBtnName[] = {"s", ""};


/*--------------------------------------*/
/*		ϐ`		*/
/*--------------------------------------*/

/*
 *	Wv(G[Jo)psۑ̈
 */
jmp_buf		_FileDialogEnv;

/*
 *	_CAO{^ID
 *		CfbNXmajorCxgIDŎw肷
 */
int		_FD_ButtonIds[MaxButtons];

/*
 *	t@CXg̃N̐擪ƍŌCyѕ\t@C̐擪
 */
fileInfo_t	*_FileInfoTop;
fileInfo_t	*_FileInfoTail;
fileInfo_t	*_FileDispTop;

/*
 *	_scrollFileList()֐Ŏgp`sNZړpƈ
 *		FD_openDialog()̐擪ŊmۂCŌŉ
 */
char		*_BufPixelBlock = NULL;

/*--------------------------------------*/
/*		[J֐錾	*/
/*--------------------------------------*/

LOCAL	void
_showFileDialog(
	fileDialog_t	*pFd);
LOCAL	int
_getCurrentDir(
	char		*path,
	fileDialog_t	*pFd);
LOCAL	void
_showDirname(
	char		*name,
	fileDialog_t	*pFd);
LOCAL	void
_initFileList(
	fileDialog_t	*pFd);
LOCAL	void
_getFiles(
	char		*pattern,
	fileDialog_t	*pFd);
LOCAL	fileInfo_t *
_makeFileInfo(
	struct find_t	*buf,
	fileInfo_t	*next,
	fileInfo_t	*prev);
LOCAL	void
_freeFileInfo(
	fileInfo_t	*top);
LOCAL	void
_sortFileList(
	fileInfo_t	*top,
	int		(*comp)(fileInfo_t *p1, fileInfo_t *p2));
LOCAL	int
_compName(
	fileInfo_t	*pFi1,
	fileInfo_t	*pFi2);
LOCAL	void
_showFileList(
	fileInfo_t	*pFi,
	fileDialog_t	*pFd);
LOCAL	void
_scrollFileList(
	int		direction,
	fileDialog_t	*pFd);
LOCAL	void
_showFilename(
	char		*name,
	fileDialog_t	*pFd);
LOCAL	long
_getFdEvent(
	fileDialog_t	*pFd);
LOCAL	int
_checkFileList(
	int		x,		/* `FbNΏۍW */
	int		y,		/*		*/
	fileDialog_t	*pFd);
LOCAL	void
_reverseFileName(
	int		fileNo,		/* ]Ώۃt@Cԍ(擪0) */
	fileDialog_t	*pFd);
LOCAL	void
_errorFatal(
	int	errorCode);


/*--------------------------------------*/
/*		֐`		*/
/*--------------------------------------*/

GLOBAL	int
FD_openDialog(
	char	*filename,		/* Iꂽt@C̃tpX */
	file_t	*fileinfo,		/* Iꂽt@C̊e */
	char	*pattern,		/* IΏۂƂt@C */
	fileDialog_t	*pFd)		/* gp_CAO\ */
/*
 *	PURPOSE
 *		݂̏݃y[Wɑ΂ăt@C_CAO\C
 *		Iꂽt@C̃tpXp^filenameŒʒmD
 *		܂Iꂽt@C̃t@CifBNgȊOjC
 *		t@CCXVC傫fileinfoŒʒmD
 *	PARAMETERS
 *		filenamep^ɂ̓t@C̒ʒmɏ[ȗ̈ւ
 *		|C^w肷邱ƁD
 *		fileInfoNULLw肵ꍇ́Ct@C͒ʒmȂD
 *		patternɂ́C_CAOɕ\It@C̃}XNp^[
 *		i. "*.*", "*.TIF"jw肷DNULLw肵ꍇ́C
 *		"*.*"w肳ꂽ̂Ƃ݂ȂD
 *		pFdNULLłΊ̃t@C_CAO
 *		(640*480 16F CLUTύXOƂ)gpD
 *		NULLłȂ΁Cw肳ꂽ_CAOgpD
 *
 *		{֐̕AC
 *		݂̏݃y[W̓_CAO\ꂽԂŁC
 *		}EXJ[\͔\ԂƂȂD
 *	RETURNS
 *		1	: t@CI
 *		0	: ID ̏ꍇ̂filename,fileinfo̓eL.
 *		< 0	: G[
 */
{
	fileDialog_t	fdStructure;
	char		bufInfo[200];		/* setupʒm̈ */
	int		drive;
	int		driveStatus[DriveQ + 1];
		/* 擪vf[0]̓_~[ŁCvf[1]珇
		 * hCuA, B, , QɑΉ
		 * 0:FPD, 1:Rsv, 2:HD, 3:RamDisk, -1:ڑ
		 */
	int		status;
	unsigned	currentDrive;
	unsigned	tmpDrive;
	unsigned	maxDrive;
	char		currentPath[PathLen];		/* [g\܂ */
	char		currentFilename[FnameLen + 1];	/* '\0'܂ */
	fileInfo_t	*saveInfoTop, *saveInfoTail, *saveDispTop;
	long		event;
	fileInfo_t	*pFi;
	int		i;
	int		retCode = 0;
	Bool_t		bExit = FALSE;
	
	/* G[p */
	if ((retCode = setjmp(_FileDialogEnv)) != 0) {
		if (_BufPixelBlock != NULL) {
			free(_BufPixelBlock);
			_BufPixelBlock = NULL;
		}
		return(-retCode);
	}
	
	/* t@Cp^[w肳ĂȂ́C"*.*"Ƃ݂Ȃ */
	if (pattern == NULL)
		pattern = "*.*";
	
	/* _CAO`̂w肳ĂȂ΁CftHg̒`̂쐬 */
	if (pFd == NULL) {
		pFd = &fdStructure;
		FD_setDefDialog(pFd);
	}
	
	/* _CAO\ */
	_showFileDialog(pFd);
	
	/* _scrollFileList()pƈm */
	_BufPixelBlock = (char *)malloc(FD_CharWidth * (FnameLen+2)
					* FD_CharHeight * FD_FilesInList);
	if (_BufPixelBlock == NULL)
		_errorFatal(NoAvailableMemory);
	
	/* ڑhCu擾 */
	ESR_setupInfo(bufInfo);
	for (drive = 1; drive < DriveQ; drive++)
		driveStatus[drive] = bufInfo[0x30 + (drive - 1) * 2];
	/* CD-ROM̃hCúC0(FPD)ƂĂ */
	driveStatus[DriveQ] = 0;
	
	/* JghCu擾C\ */
	_dos_getdrive(&currentDrive);
	tmpDrive = currentDrive;
	
	BTN_setName(_FD_ButtonIds[BtnDriveCenter],  FD_DriveName[currentDrive]);	
	/* EnableɂȂĂ邽 BTN_enable()͌Ă΂Ȃ */
	
	/* Kvȕϐ */
	_FileInfoTop = _FileInfoTail = _FileDispTop = NULL;
	currentFilename[0] = '\0';
	
	/* }EX\ */
	MOU_display(On);
	
	/* JgfBgN擾C\ */
	status = _getCurrentDir(currentPath, pFd);
	
	/* t@CXg */
	_initFileList(pFd);
	
	if (status == 0)
		/* t@Cꗗ擾C\ */
		_getFiles(pattern, pFd);
	
	/* Cxg */
	do {
		event = _getFdEvent(pFd);
		switch (major(event)) {
		case BtnDriveLeft:
			/*
			 * JghCu瑼ɈړꍇC
			 * pXCt@CXgCt@C̈
			 */
			if (tmpDrive == currentDrive) {
				_showDirname("\\", pFd);
				/* t@CXgϐۑ */
				saveInfoTop = _FileInfoTop;
				saveInfoTail = _FileInfoTail;
				saveDispTop = _FileDispTop;
				/* t@C񂪃t[Ȃ悤ɂ */
				_FileInfoTop = NULL;
				/* t@CXg̈ */
				_initFileList(pFd);
				/* t@C̈ */
				_showFilename("", pFd);
			}
			/* JghCuύX */
			do {
				tmpDrive--;
				if (tmpDrive == 0)
					tmpDrive = DriveQ;
				status = driveStatus[tmpDrive];
			} while (status != 0 && status != 2 && status != 3);
			
			/* hCu{^\̕ύX */
			MOU_display(Off);
			BTN_setName(_FD_ButtonIds[BtnDriveCenter],
				FD_DriveName[tmpDrive]);
			MOU_display(On);
			/*
			 * JghCuɈړꍇC
			 * e\𕜌
			 */
			if (tmpDrive == currentDrive) {
				_showDirname(currentPath, pFd);
				_FileInfoTop = saveInfoTop;
				_FileInfoTail = saveInfoTail;
				_FileDispTop = saveDispTop;
				_showFileList(_FileDispTop, pFd);
				/* It@C݂ꍇC\ */
				MOU_display(Off);
				pFi = _FileDispTop;
				for (i = 0; i < FD_FilesInList; i++) {
					if (pFi == NULL)
						break;
					if (pFi -> select == TRUE)
						_reverseFileName(i, pFd);
					pFi = pFi -> next;
				}
				MOU_display(On);
				_showFilename(currentFilename, pFd);
			}
			break;
			
		case BtnDriveCenter:
			/* Wait}EXJ[\ɕύX */
			MOU_setCursorType(1);
			
			/* JghCuݒ */
			_dos_setdrive(tmpDrive, &maxDrive);
			
			/* JghCu擾C\ */
			_dos_getdrive(&currentDrive);
			tmpDrive = currentDrive;
			
			/* JgfBgN擾C\ */
			status = _getCurrentDir(currentPath, pFd);
			_initFileList(pFd);
			if (status == 0)
				/* t@Cꗗ擾C\ */
				_getFiles(pattern, pFd);
				
			/* t@C */
			currentFilename[0] = '\0';
			_showFilename(currentFilename, pFd);
			
			/* VXe}EXJ[\ɕύX */
			MOU_setCursorType(0);
			
			break;
			
		case BtnDriveRight:
			/*
			 * JghCu瑼ɈړꍇC
			 * pXCt@CXgCt@C̈
			 */
			if (tmpDrive == currentDrive) {
				_showDirname("\\", pFd);
				/* t@CXgϐۑ */
				saveInfoTop = _FileInfoTop;
				saveInfoTail = _FileInfoTail;
				saveDispTop = _FileDispTop;
				/* t@C񂪃t[Ȃ悤ɂ */
				_FileInfoTop = NULL;
				/* t@CXg̈ */
				_initFileList(pFd);
				/* t@C̈ */
				_showFilename("", pFd);
			}
			/* JghCuύX */
			do {
				tmpDrive++;
				if (tmpDrive == DriveQ + 1)
					tmpDrive = 1;		/* Drive A: */
				status = driveStatus[tmpDrive];
			} while (status != 0 && status != 2 && status != 3);
			
			/* hCu{^\̕ύX */
			MOU_display(Off);
			BTN_setName(_FD_ButtonIds[BtnDriveCenter],
				FD_DriveName[tmpDrive]);
			MOU_display(On);
			/*
			 * JghCuɈړꍇC
			 * e\𕜌
			 */
			if (tmpDrive == currentDrive) {
				_showDirname(currentPath, pFd);
				_FileInfoTop = saveInfoTop;
				_FileInfoTail = saveInfoTail;
				_FileDispTop = saveDispTop;
				_showFileList(_FileDispTop, pFd);
				/* It@C݂ꍇC\ */
				MOU_display(Off);
				pFi = _FileDispTop;
				for (i = 0; i < FD_FilesInList; i++) {
					if (pFi == NULL)
						break;
					if (pFi -> select == TRUE)
						_reverseFileName(i, pFd);
					pFi = pFi -> next;
				}
				MOU_display(On);
				_showFilename(currentFilename, pFd);
			}
			break;
			
		case BtnParent:
			/* JgfBNgύX */
			chdir("..");
			
			/* JgfBNg擾C\ */
			status = _getCurrentDir(currentPath, pFd);
			_initFileList(pFd);
			if (status == 0)
				/* t@Cꗗ\ */
				_getFiles(pattern, pFd);
			
			/* t@C */
			currentFilename[0] = '\0';
			_showFilename(currentFilename, pFd);
			
			break;
			
		case BtnScrollUp:
		case BtnScrollDown:
			/* t@CꗗXN[ */
			_scrollFileList(major(event), pFd);
			break;
			
		case BtnOk:
			/* Iꂽt@Cfilenameɐݒ */
			if (strlen(currentFilename)) {
				filename[0] = currentDrive + 'A' - 1;
				filename[1] = ':';
				filename[2] = '\0';
				strcat(filename, currentPath);
				if (strcmp(currentPath, "\\"))
					strcat(filename, "\\");
				strcat(filename, currentFilename);
				bExit = TRUE;
				retCode = 0;
			}
			break;
			
		case BtnCancel:
			bExit = TRUE;
			retCode = 1;
			break;
			
		case FileList:
			pFi = _FileDispTop;
			for (i = 0; i < minor(event); i++)
				pFi = pFi -> next;
			
			if (pFi -> attr & _A_SUBDIR) {
				/* JgfBNgύX */
				chdir(pFi -> name);
				
				/* JgfBNg擾C\ */
				status = _getCurrentDir(currentPath, pFd);
				_initFileList(pFd);
				if (status == 0)
					/* t@Cꗗ\ */
					_getFiles(pattern, pFd);
				
				/* t@C */
				currentFilename[0] = '\0';
				_showFilename(currentFilename, pFd);
			}
			else {
				/* Iꂽt@Cfilenameɐݒ */
				pFi -> select = TRUE;
				strcpy(currentFilename, pFi -> name);
				
				/* ẽt@Cʒm */
				if (fileinfo != NULL) {
					strcpy(fileinfo -> name, pFi -> name);
					fileinfo -> attr = pFi -> attr;
					fileinfo -> date = pFi -> date;
					fileinfo -> time = pFi -> time;
					fileinfo -> size = pFi -> size;
				}
				/* t@C\ */
				_showFilename(currentFilename, pFd);
			}
			break;
		}
	} while (bExit != TRUE);
	
	/* gp */
	_freeFileInfo(_FileInfoTop);
	free(_BufPixelBlock);
	_BufPixelBlock = NULL;
	
	BTN_allDestroy();
	
	MOU_display(Off);
	
	return(retCode);
}
/* ---	FD_openDialog()  --- */


GLOBAL	void
FD_setDefDialog(
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		ftHgt@C_CAO쐬D
 *		{_CAO640~480hbg̉ʂz肵ĂD
 */
{
	/* t@C_CAȌݒ */
	pFd -> originX	= FD_DialogPosX;
	pFd -> originY	= FD_DialogPosY;
	pFd -> title	= NULL;			/* ^Cg͖ */
	pFd -> titleX	= -1;			/* Z^Ow */
	pFd -> titleY	= FD_TopMargin;
	pFd -> driveLX	= FD_LeftMargin;
	pFd -> driveLY	= pFd->titleY + FD_CharHeight + 8;
	pFd -> driveCX	= pFd->driveLX + FD_CharWidth + 8 * 2;
	pFd -> driveCY	= pFd->driveLY;
	pFd -> driveRX	= pFd->driveCX + FD_DriveBtnWidth;
	pFd -> driveRY	= pFd->driveLY;
	pFd -> pathX	= FD_LeftMargin;
	pFd -> pathY	= pFd->driveLY + FD_ButtonHeight + 8;
	pFd -> parentX	= pFd->pathX + FD_CharWidth * FnameLen + 8;
	pFd -> parentY	= pFd->driveLY + FD_CharHeight + 8;
	pFd -> fileListX = FD_LeftMargin;
	pFd -> fileListY = pFd->pathY + FD_CharHeight + 8;
	pFd -> upX	= pFd->fileListX + FD_CharWidth * (FnameLen+2) + 8;
	pFd -> upY	= pFd->fileListY;
	pFd -> downX	= pFd->upX;
	pFd -> downY	= pFd->fileListY + FD_CharHeight * (FD_FilesInList-1);
	pFd -> fileNameX = FD_LeftMargin;
	pFd -> fileNameY = pFd->fileListY + FD_CharHeight * FD_FilesInList + 8;
	pFd -> okX	= FD_LeftMargin + 48;
	pFd -> okY	= pFd->fileNameY + FD_CharHeight + 8;
	pFd -> cancelX	= pFd->okX + FD_OkNgBtnWidth + 8;
	pFd -> cancelY	= pFd->okY;
	pFd -> rightBottomX = pFd->cancelX + FD_OkNgBtnWidth + FD_RightMargin;
	pFd -> rightBottomY = pFd->okY + FD_ButtonHeight + FD_BottomMargin;
}
/* ---	FD_setDefDialog()  --- */


LOCAL	void
_showFileDialog(
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		t@C_CAO\D
 */
{
	int		width, x;
	button_t	button;
	
	/* wi̐ݒ */
	DISP_rectangle(
		pFd->originX,
		pFd->originY,
		pFd->originX + pFd->rightBottomX - 1,
		pFd->originY + pFd->rightBottomY - 1,
		CI_Gray);
	
	/* g̐ݒ */
	DISP_rectBox(
		pFd->originX,
		pFd->originY,
		pFd->originX + pFd->rightBottomX - 1,
		pFd->originY + pFd->rightBottomY - 1,
		CI_Black);
	
	/* _CAO^Cg\ */
	if (pFd -> title != NULL) {

		/* \JnxW߂ */
		if (pFd -> titleX == -1) {
			/* Z^O */
			width = strlen(pFd -> title) * FD_CharWidth;
			if ((x = pFd->rightBottomX - width) < 0)
				x = 0;
			x /= 2;
		}
		else
			x = pFd -> titleX;
		
		DISP_stringAt(
			pFd->title,
			pFd->originX + x,
			pFd->originY + pFd->titleY + FD_CharHeight - 1,
			CI_Black);
	}
	
	/* pX\GA쐬 */
	DISP_rectangle(
		pFd->originX + pFd->pathX,
		pFd->originY + pFd->pathY,
		pFd->originX + pFd->pathX + FD_CharWidth * FnameLen - 1,
		pFd->originY + pFd->pathY + FD_CharHeight - 1,
		CI_Black);
		
	/* t@CXgGA쐬 */
	DISP_rectangle(
	    pFd->originX + pFd->fileListX,
	    pFd->originY + pFd->fileListY,
	    pFd->originX + pFd->fileListX + FD_CharWidth * (FnameLen+2) - 1,
	    pFd->originY + pFd->fileListY + FD_CharHeight * FD_FilesInList - 1,
	    CI_Black);
		
	/* t@CGA쐬 */
	DISP_rectangle(
		pFd->originX + pFd->fileNameX,
		pFd->originY + pFd->fileNameY,
		pFd->originX + pFd->fileNameX + FD_CharWidth * FnameLen - 1,
		pFd->originY + pFd->fileNameY + FD_CharHeight - 1,
		CI_Black);
	
	/* hCu{^쐬 */
	button.string	= "<";
	button.enable	= TRUE;
	button.repeat	= FALSE;
	button.luX	= pFd->originX + pFd->driveLX;
	button.luY	= pFd->originY + pFd->driveLY;
	_FD_ButtonIds[BtnDriveLeft] = BTN_create(&button);
	
	button.string	= FD_DriveName[0];
	button.enable	= TRUE;
	button.repeat	= FALSE;
	button.luX	= pFd->originX + pFd->driveCX;
	button.luY	= pFd->originY + pFd->driveCY;
	_FD_ButtonIds[BtnDriveCenter] = BTN_create(&button);
	
	button.string	= ">";
	button.enable	= TRUE;
	button.repeat	= FALSE;
	button.luX	= pFd->originX + pFd->driveRX;
	button.luY	= pFd->originY + pFd->driveRY;
	_FD_ButtonIds[BtnDriveRight] = BTN_create(&button);
	
	/* efBNg{^쐬 */
	button.string	= FD_ParentBtnName;
	button.enable	= FALSE;
	button.repeat	= FALSE;
	button.luX	= pFd->originX + pFd->parentX;
	button.luY	= pFd->originY + pFd->parentY;
	_FD_ButtonIds[BtnParent] = BTN_create(&button);
	
	/* XN[{^쐬 */
	button.string	= FD_ScrollBtnName[0];
	button.enable	= FALSE;
	button.repeat	= TRUE;			/* repeat L */
	button.luX	= pFd->originX + pFd->upX;
	button.luY	= pFd->originY + pFd->upY;
	_FD_ButtonIds[BtnScrollUp] = BTN_create(&button);
	
	button.string	= FD_ScrollBtnName[1];
	button.enable	= FALSE;
	button.repeat	= TRUE;			/* repeat L */
	button.luX	= pFd->originX + pFd->downX;
	button.luY	= pFd->originY + pFd->downY;
	_FD_ButtonIds[BtnScrollDown] = BTN_create(&button);
	
	/* mF{^쐬 */
	button.string	= FD_OkNgBtnName[0];
	button.enable	= FALSE;		/* ŏ disable  */
	button.repeat	= FALSE;
	button.luX	= pFd->originX + pFd->okX;
	button.luY	= pFd->originY + pFd->okY;
	_FD_ButtonIds[BtnOk] = BTN_create(&button);
	
	button.string	= FD_OkNgBtnName[1];
	button.enable	= TRUE;
	button.repeat	= FALSE;
	button.luX	= pFd->originX + pFd->cancelX;
	button.luY	= pFd->originY + pFd->cancelY;
	_FD_ButtonIds[BtnCancel] = BTN_create(&button);
}
/* ---	_showFileDialog()  --- */


LOCAL	int
_getCurrentDir(
	char		*path,
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		JgfBNg擾C
 *		[g \ ܂񂾃tpXpathɕԂD
 *		܂C_CAÕpX\GAɂ\C
 *		efBNgړ{^enable/disable𐧌䂷D
 *		G[ɂ́Cpath"????????"\ʒmD
 *	RETURNS
 *		0	: I
 *		-1	: G[
 */
{
	char	*p;
	int	ret;
	
	path[0] = '\\';
	p = getcwd(&path[1], PathLen);
	if (p != NULL) {		/* G[ */
		ret = 0;
	}
	else {				/* G[ */
		strcpy(&path[1], "????????");
		ret = -1;
	}
	_showDirname(path, pFd);
	return(ret);
}
/* ---	_getCurrentDir()  --- */


LOCAL	void
_showDirname(
	char		*path,
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		pẌCw肳ꂽpX̍ŏIfBNg
 *		\D
 *		̌CefBNgړ{^enable/disableݒ肷D
 *		nꂽpX̓[g \ ܂łƂ݂ȂD
 */
{
	char	*p;
	
	/* }EX\ɂ */
	MOU_display(Off);
	
	/* pẌ */
	DISP_rectangle(
		pFd->originX + pFd->pathX,
		pFd->originY + pFd->pathY,
		pFd->originX + pFd->pathX + FD_CharWidth * FnameLen - 1,
		pFd->originY + pFd->pathY + FD_CharHeight - 1,
		CI_Black);
	
	/* fBNgo */
	p = (char *)jstrrchr((unsigned char *)path, '\\');
	
	/* \̎̕pẌɕ\ */
	p++;
	DISP_stringAt(p,
		pFd->originX + pFd->pathX,
		pFd->originY + pFd->pathY + FD_CharHeight - 1,
		CI_White);
	/*
	 * [gfBNgCǂݍݎsfBNgȂC
	 * efBNgړ{^disable
	 */
	if (*p == '\0' || strcmp(p, "????????") == 0)
		BTN_enable(_FD_ButtonIds[BtnParent], FALSE);
	else
	/*
	 * ʏ̃TufBNgȂC
	 * efBNgړ{^enable
	 */
		BTN_enable(_FD_ButtonIds[BtnParent], TRUE);
		
	/* }EX\ */
	MOU_display(On);
}
/* ---	_showDirname()  --- */


LOCAL	void
_initFileList(
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		t@CXg̉Ct@CXg̈̏
 *		XN[{^disablesD
 *	GLOBAL VAR. (set)
 *		_FileInfoTop, _FileInfoTail, _FileDispTop
 */
{
	/* t@CXg */
	_freeFileInfo(_FileInfoTop);
	_FileInfoTop = _FileInfoTail = _FileDispTop = NULL;
	
	/* }EX\ɂ */
	MOU_display(Off);
	
	/* t@CXg̈ */
	DISP_rectangle(
	    pFd->originX + pFd->fileListX,
	    pFd->originY + pFd->fileListY,
	    pFd->originX + pFd->fileListX + FD_CharWidth * (FnameLen+2) - 1,
	    pFd->originY + pFd->fileListY + FD_CharHeight * FD_FilesInList - 1,
	    CI_Black);
	
	/* XN[{^disable */
	BTN_enable(_FD_ButtonIds[BtnScrollUp], FALSE);
	BTN_enable(_FD_ButtonIds[BtnScrollDown], FALSE);

	/* }EX\ */
	MOU_display(On);
}
/* ---	_initFileList()  --- */


LOCAL	void
_getFiles(
	char		*pattern,
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		JgfBNgɑ݂TufBNgƃt@C
 *		擾Ct@CXg̐ƃt@CXg_CAO
 *		\sD
 *		STufBNgpatternŎw肳ꂽt@C
 *		ʏt@CD
 *	GLOBAL VAR. (set)
 *		_FileInfoTop, _FileInfoTail, _FileDispTop
 */
{
	fileInfo_t	*pFi;
	struct find_t	fBuf;
	
	_FileInfoTop = _FileInfoTail = NULL;
	
	/* TufBNgT */
	if (_dos_findfirst("*.*", _A_SUBDIR, &fBuf) == 0) {
		
		/* TufBNg̏ꍇC. Gg͑ΏۊO */
		if (strcmp(fBuf.name, ".") == 0) {
			/*  .. Ggǂݔ΂ */
			_dos_findnext(&fBuf);
		}
		else {
			if (fBuf.attrib & _A_SUBDIR) {
				pFi = _makeFileInfo(&fBuf, NULL, _FileInfoTail);
				if (pFi == NULL)
					_errorFatal(NoAvailableMemory);
				_FileInfoTop = pFi;
				_FileInfoTail = pFi;
			}
		}
		while (_dos_findnext(&fBuf) == 0) {
			if (fBuf.attrib & _A_SUBDIR) {
				pFi = _makeFileInfo(&fBuf, NULL, _FileInfoTail);
				if (pFi == NULL)
					_errorFatal(NoAvailableMemory);
				if (_FileInfoTop == NULL) {
					_FileInfoTop = pFi;
					_FileInfoTail = pFi;
				}
				else {
					_FileInfoTail -> next = pFi;
					_FileInfoTail = pFi;
				}
			}
		}
	}
	
	/* t@CT */
	if (_dos_findfirst(pattern, _A_NORMAL, &fBuf) == 0) {
		
		pFi = _makeFileInfo(&fBuf, NULL, _FileInfoTail);
		if (pFi == NULL)
			_errorFatal(NoAvailableMemory);
		if (_FileInfoTop == NULL) {
			_FileInfoTop = pFi;
			_FileInfoTail = pFi;
		}
		else {
			_FileInfoTail -> next = pFi;
			_FileInfoTail = pFi;
		}
		
		while (_dos_findnext(&fBuf) == 0) {
			pFi = _makeFileInfo(&fBuf, NULL, _FileInfoTail);
			if (pFi == NULL)
				_errorFatal(NoAvailableMemory);
			_FileInfoTail -> next = pFi;
			_FileInfoTail = pFi;
		}
	}
	/* \[g: t@C */
	_sortFileList(_FileInfoTop, _compName);
	
	/* t@CXg\ */
	_showFileList(_FileInfoTop, pFd);
	_FileDispTop = _FileInfoTop;
}
/* ---	_getFiles()  --- */


LOCAL	fileInfo_t *
_makeFileInfo(
	struct find_t	*buf,		/* _dos_find**** ̌ */
	fileInfo_t	*next,
	fileInfo_t	*prev)
/*
 *	PURPOSE
 *		t@C̈mۂCKvȏݒ肷D
 *	RETURNS
 *		NULL	: mۂt@Cւ̃|C^
 *		NULL	: sɂmێs
 */
{
	fileInfo_t	*pFi;
	
	pFi = (fileInfo_t *)malloc(sizeof(fileInfo_t));
	if (pFi == NULL)
		return(NULL);		/* malloc()s */
	
	pFi -> next	= next;
	pFi -> prev	= prev;
	strcpy(pFi -> name, buf -> name);
	pFi -> attr	= buf -> attrib;
	pFi -> date	= buf -> wr_date;
	pFi -> time	= buf -> wr_time;
	pFi -> size	= buf -> size;
	pFi -> select	= FALSE;
	return(pFi);
}
/* ---	_makeFileInfo()  --- */


LOCAL	void
_freeFileInfo(
	fileInfo_t	*top)		/* 擪m[h */
/*
 *	PURPOSE
 *		t@C񃊃XgD
 */
{
	fileInfo_t	*pFi;
	fileInfo_t	*next;
	
	for (pFi = top; pFi != NULL; pFi = next) {
		next = pFi -> next;
		free(pFi);
	}
}
/* ---	_freeFileInfo()  --- */


LOCAL	void
_sortFileList(
	fileInfo_t	*top,
	int		(*comp)(fileInfo_t *p1, fileInfo_t *p2))
/*
 *	PURPOSE
 *		t@C̃Xgt@C̏Ƀ\[gD
 *	IMPLEMENT
 *		őTꊷ@(?)
 */
{
	fileInfo_t	*p, *min;
	fileInfo_t	temp;
	
	/* \[gΏۂ܂݂Ȃ΁CɕA */
	if (top == NULL)
		return;
		
	for ( ; top -> next != NULL; top = top -> next) {
		min = top;
		for (p = top -> next; p != NULL; p = p -> next)
			if ((*comp)(p, min) < 0)
				min = p;
		if (min != top) {
			/* ꊷs */
			strcpy(&temp.name[0], min -> name);
			temp.attr = min -> attr;
			temp.date = min -> date;
			temp.time = min -> time;
			temp.size = min -> size;
			strcpy(min -> name, top -> name);
			min -> attr = top -> attr;
			min -> date = top -> date;
			min -> time = top -> time;
			min -> size = top -> size;
			strcpy(top -> name, &temp.name[0]);
			top -> attr = temp.attr;
			top -> date = temp.date;
			top -> time = temp.time;
			top -> size = temp.size;
		}
	}
}
/* ---	sortFileInfo()  --- */


LOCAL	int
_compName(
	fileInfo_t	*pFi1,
	fileInfo_t	*pFi2)
/*
 *	PURPOSE
 *		t@CrCrʂʒmD
 *		fBNǵCt@C菬D
 *		̒ł́Ct@C^fBNg̏ɏ]D
 *	RETURNS
 *		1	: pFi1  pFi2 傫
 *		0	: pFi1  pFi2 ͓
 *		-1	: pFi1  pFi2 菬
 */
{
	if (pFi1 -> attr & _A_SUBDIR) {
		if (pFi2 -> attr & _A_SUBDIR)
			return(strcmp(pFi1 -> name, pFi2 -> name));
		return(-1);
	}
	else {
		if (pFi2 -> attr & _A_SUBDIR)
			return(1);
		return(strcmp(pFi1 -> name, pFi2 -> name));
	}
	/* ɂ͓BȂ */
}
/* ---	_compName()  --- */


LOCAL	void
_showFileList(
	fileInfo_t	*pFi,
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		t@C̃Xgt@CXg̈ɕ\C
 *		KvɉăXN[{^enableɂD
 */
{
	int	i;
	char	name[15];
	
	/* }EX\ɂ */
	MOU_display(Off);
	
	/* XN[{^enable */
	if (pFi != NULL && pFi -> prev != NULL)
		BTN_enable(_FD_ButtonIds[BtnScrollUp], TRUE);
	
	/* t@CXg\ */
	for (i = 0; i < FD_FilesInList; i++) {
		if (pFi == NULL)
			break;
		/*
		 * TufBNgȂC< >Ŋĕ\D
		 */
		if (pFi -> attr & _A_SUBDIR) {
			strcpy(name, "<");
			strcat(name, pFi -> name);
			strcat(name, ">");
		}
		else
			strcpy(name, pFi -> name);
		
		DISP_stringAt(
		    name,
		    pFd->originX + pFd->fileListX,
		    pFd->originY + pFd->fileListY + FD_CharHeight * (i+1) - 1,
		    CI_White);
		pFi = pFi -> next;
	}
	/* XN[{^enable */
	if (pFi != NULL)
		BTN_enable(_FD_ButtonIds[BtnScrollDown], TRUE);
	
	/* }EX\ */
	MOU_display(On);
}
/* ---	_showFileList()  --- */


LOCAL	void
_scrollFileList(
	int		direction,
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		t@CXgdirectionŎw肳ꂽɃXN[D
 *		XN[Ώۃt@CɉāC
 *		XN[{^enableύXD
 *	GLOBAL VAR. (set)
 *		_FileDispTop
 */
{
	int		i;
	fileInfo_t	*pFi;
	int		luX, luY, rdX, rdY;
	int		lu2X, lu2Y, rd2X, rd2Y;
	int		lueX, lueY, rdeX, rdeY;
	char		name[15];
	int		revFile;
	int		btn1, btn2;
	fileInfo_t	*btn2On;
	
	switch (direction) {
	case BtnScrollDown:		/*  */
		for (pFi = _FileDispTop, i = 0; i < FD_FilesInList; i++)
			pFi = pFi -> next;
		_FileDispTop = _FileDispTop -> next;
		revFile = FD_FilesInList - 1;
		
		/* XN[{^enable */
		btn1 = _FD_ButtonIds[BtnScrollUp];
		btn2 = _FD_ButtonIds[BtnScrollDown];
		btn2On = pFi -> next;
		
		/* ʌ̈̐ݒ */
		luX = pFd->originX + pFd->fileListX;
		luY = pFd->originY + pFd->fileListY + FD_CharHeight;
		rdX = pFd->originX + pFd->fileListX
			+ FD_CharWidth * (FnameLen+2) - 1;
		rdY = pFd->originY + pFd->fileListY
			+ FD_CharHeight * FD_FilesInList - 1;
		
		/* ʐ̈̐ݒ */
		lu2X = pFd->originX + pFd->fileListX;
		lu2Y = pFd->originY + pFd->fileListY;
		rd2X = pFd->originX + pFd->fileListX
			+ FD_CharWidth * (FnameLen+2) - 1;
		rd2Y = pFd->originY + pFd->fileListY
			+ FD_CharHeight * (FD_FilesInList-1) - 1;
		
		/* ̈̐ݒ */
		lueX = pFd->originX + pFd->fileListX;
		lueY = pFd->originY + pFd->fileListY
			+ FD_CharHeight * (FD_FilesInList-1);
		rdeX = pFd->originX + pFd->fileListX
			+ FD_CharWidth * (FnameLen+2) - 1;
		rdeY = pFd->originY + pFd->fileListY
			+ FD_CharHeight * FD_FilesInList - 1;
		break;
		
	case BtnScrollUp:		/*  */
		pFi = _FileDispTop -> prev;
		_FileDispTop = _FileDispTop -> prev;
		revFile = 0;
		
		/* XN[{^enable */
		btn1 = _FD_ButtonIds[BtnScrollDown];
		btn2 = _FD_ButtonIds[BtnScrollUp];
		btn2On = pFi -> prev;
		
		/* ʌ̈̐ݒ */
		luX = pFd->originX + pFd->fileListX;
		luY = pFd->originY + pFd->fileListY;
		rdX = pFd->originX + pFd->fileListX
			+ FD_CharWidth * (FnameLen+2) - 1;
		rdY = pFd->originY + pFd->fileListY
			+ FD_CharHeight * (FD_FilesInList-1) - 1;
		
		/* ʐ̈̐ݒ */
		lu2X = pFd->originX + pFd->fileListX;
		lu2Y = pFd->originY + pFd->fileListY + FD_CharHeight;
		rd2X = pFd->originX + pFd->fileListX
			+ FD_CharWidth * (FnameLen+2) - 1;
		rd2Y = pFd->originY + pFd->fileListY
			+ FD_CharHeight * FD_FilesInList - 1;
		
		/* ̈̐ݒ */
		lueX = pFd->originX + pFd->fileListX;
		lueY = pFd->originY + pFd->fileListY;
		rdeX = pFd->originX + pFd->fileListX
			+ FD_CharWidth * (FnameLen+2) - 1;
		rdeY = pFd->originY + pFd->fileListY + FD_CharHeight - 1;
		break;
		
	default:
		_errorFatal(IllegalDirection);
		break;
	}
	/* t@CXg̈̈ړCC\ */
	MOU_display(Off);
	DISP_getPixelBlock(luX, luY, rdX, rdY, _BufPixelBlock);
	DISP_putPixelBlock(lu2X, lu2Y, rd2X, rd2Y, _BufPixelBlock);
	DISP_rectangle(lueX, lueY, rdeX, rdeY, CI_Black);
	/*
	 * TufBNgȂC< >Ŋĕ\D
	 */
	if (pFi -> attr & _A_SUBDIR) {
		strcpy(name, "<");
		strcat(name, pFi -> name);
		strcat(name, ">");
	}
	else
		strcpy(name, pFi -> name);
	
	DISP_stringAt(name, lueX, rdeY, CI_White);
	
	if (pFi -> select == TRUE)
		_reverseFileName(revFile, pFd);
		
	/* XN[{^enable */
	BTN_enable(btn1, TRUE);
	BTN_enable(btn2, (btn2On != NULL) ? TRUE : FALSE);

	MOU_display(On);
}
/* ---	_scrollFileList()  --- */


LOCAL	void
_showFilename(
	char		*name,
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		t@C̈Cw肳ꂽt@C\D
 *		t@C󕶎łȂ΁CmF{^enableC
 *		󕶎ł΁CmF{^disableD
 */
{
	/* }EX\ɂ */
	MOU_display(Off);
	
	/* t@CGA */
	DISP_rectangle(
		pFd->originX + pFd->fileNameX,
		pFd->originY + pFd->fileNameY,
		pFd->originX + pFd->fileNameX + FD_CharWidth * FnameLen - 1,
		pFd->originY + pFd->fileNameY + FD_CharHeight - 1,
		CI_Black);
	
	/* t@C\ */
	DISP_stringAt(
		name,
		pFd->originX + pFd->fileNameX,
		pFd->originY + pFd->fileNameY + FD_CharHeight - 1,
		CI_White);
		
	/* mF{^̕\ύX */
	BTN_enable(_FD_ButtonIds[BtnOk], (*name == '\0') ? FALSE : TRUE);
	
	/* }EX\ */
	MOU_display(On);
}
/* ---	_showFilename()  --- */


LOCAL	long
_getFdEvent(
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		CxgʒmD
 *		}EX{^̃NbN݂̂CCxg𔭐D
 *		Cxg̓{^Cxgƃt@CXgCxgɕD
 *		{^enableł݂̂̂Cxg𔭐D
 *		t@CXgɃt@C\Ăꍇ̂݁C
 *		t@CCxgDt@CCxgł́C
 *		t@CXgł̈ʒuminorCxgIDŒʒmD
 *	RETURNS
 *		CxgID
 *	GLOBAL VAR. (ref)
 *		_FileInfoTop, _FileDispTop
 */
{
	int	item;
	int	mosX, mosY;
	int	mosButton;
	int	btnStatus;
	int	pushedBtn;		/* ʏ탂[hŉꂽ{^ID */
	int	selectedFile, newFile;
	int	i;
	static	int	repeatId = -1;	/* repeat[hɓCxgID */
	fileInfo_t	*pFi;
	
	while (1) {
		pushedBtn = -1;
		selectedFile = -1;
		
		/* repeat[h̏s */
		if (repeatId != -1) {
			do {
				mosButton = MOU_readPosition(&mosX, &mosY);
				if (mosButton & MouseLeftButton)
					/*
					 * {^ꑱĂ΁C
					 * AD
					 */
					if (BTN_posCheck(_FD_ButtonIds[repeatId],
							mosX, mosY) == 1) {
					    return(repeatId);
					}
			} while (mosButton & MouseLeftButton);
			
			/* repeat[hI */
			MOU_display(Off);
			BTN_reverse(_FD_ButtonIds[repeatId]);
			MOU_display(On);
			repeatId = -1;
		}
		
		/* {^̂҂ */
		MOU_waitPress(MouseLeftButton, &mosX, &mosY);
		
		/* _CAOACe{^ꂽ`FbN */
		for (item = 0; item < MaxButtons; item++) {
			if (BTN_posCheck(_FD_ButtonIds[item], mosX, mosY) == 1) {
				pushedBtn = _FD_ButtonIds[item];
				break;
			}
		}
		
		/* ĂȂ΁Ct@CXg`FbN */
		if (pushedBtn == -1)
			selectedFile = _checkFileList(mosX, mosY, pFd);
		
		/*
		 * {^̉Ώ(ACe{^Ct@CXg, ̑)
		 * Ƃɏ
		 */
		
		/* ACe{^Ă */
		if (pushedBtn != -1) {
		
			/* {^𔽓]\ */
			MOU_display(Off);
			BTN_reverse(pushedBtn);
			MOU_display(On);
			btnStatus = ~FALSE;
			/*
			 * repeat{^ł΁C
			 * repeatIDݒ肵CɕAD
			 */
			if (BTN_isRepeat(pushedBtn)) {
				repeatId = item;
				return(item);
			}
			/*
			 * {^Ă
			 * }EẌʒuɂ{^\ύXC
			 * {^̂҂
			 */
			do {
				mosButton = MOU_readPosition(&mosX, &mosY);
				if (btnStatus != FALSE &&
				    !BTN_posCheck(pushedBtn, mosX, mosY)) {
					MOU_display(Off);
					BTN_reverse(pushedBtn);
					MOU_display(On);
					btnStatus = FALSE;
				}
				else if (btnStatus == FALSE &&
				    BTN_posCheck(pushedBtn, mosX, mosY)) {
					MOU_display(Off);
					BTN_reverse(pushedBtn);
					MOU_display(On);
					btnStatus = ~FALSE;
				}
			} while (mosButton & MouseLeftButton);
			/*
			 * {^ꂽ_ŁC}EXJ[\
			 * ŏɉꂽ{^ɂ΁C{^߂ďID
			 * Ȃ΁C֖߂D
			 */
			if (btnStatus != FALSE) {
				MOU_display(Off);
				BTN_reverse(pushedBtn);
				MOU_display(On);
				return(item);
			}
		}
		
		/* t@CXgIĂ */ 
		else if (selectedFile != -1) {
		
			/*
			 * ɑ݂锽]\ɖ߂C
			 * w肳ꂽڂ𔽓]\D
			 */
			MOU_display(Off);
			for (i = 0, pFi = _FileDispTop; i < FD_FilesInList; i++) {
				if (pFi == NULL)
					break;
				if (pFi -> select == TRUE)
					_reverseFileName(i, pFd);
				pFi -> select = FALSE;
				pFi = pFi -> next;
			}
			for (pFi = _FileInfoTop; pFi != NULL; pFi = pFi -> next)
				pFi -> select = FALSE;
			_reverseFileName(selectedFile, pFd);
			MOU_display(On);
			/*
			 * {^ĂԁC}EẌʒuɂ
			 * t@C̔]\ύXC
			 * {^̂҂D
			 */
			do {
				mosButton = MOU_readPosition(&mosX, &mosY);
				newFile = _checkFileList(mosX, mosY, pFd);
				
				if (selectedFile != -1 &&
				    newFile != selectedFile) {
					MOU_display(Off);
					_reverseFileName(selectedFile, pFd);
					MOU_display(On);
				}
				if (newFile != -1 &&
				    selectedFile != newFile) {
					MOU_display(Off);
					_reverseFileName(newFile, pFd);
					MOU_display(On);
				}
				
				selectedFile = newFile;
				
			} while (mosButton & MouseLeftButton);
			/*
			 * {^ꂽ_ŁC}EXJ[\
			 * t@Cɂ΁Ĉ܂܏ID
			 * Ȃ΁C֖߂D
			 */
			if (newFile != -1) {
				return((newFile << 16) | FileList);
			}
		}
		
		/* ȊÖ̗ŉĂꍇ */
		else {
			/* {^̂҂C֖߂ */
			MOU_waitRelease(MouseLeftButton, &mosX, &mosY);
		}
	}
	/* ɂ͓BȂ߁Creturn͂Ȃ */
}
/* ---	_getFdEvent()  --- */


LOCAL	int
_checkFileList(
	int		x,		/* `FbNΏۍW */
	int		y,		/*		*/
	fileDialog_t	*pFd)
/*
 *	PURPOSE
 *		w肵WC
 *		t@CXgɕ\̃t@ĈC
 *		Ԗڂ̃t@C̈ʒuɑ邩𔻒肵āCʒmD
 *		t@CXgłĂCt@C\ĂȂʒu
 *		ł΁C-1 ʒmD
 *	RETURNS
 *		-1	: w肵W̓t@CwĂȂ
 *		>= 0	: t@Cԍ(擪0)
 *	GLOBAL VAR. (ref)
 *		_FileDispTop
 */
{
	int	i;
	int	checkY;
	fileInfo_t	*pFi;
	
	/* t@CXgH */
	if (pFd->originX + pFd->fileListX > x ||
	    pFd->originX + pFd->fileListX + FD_CharWidth * (FnameLen+2) - 1 < x)
		return(-1);
	if (pFd->originY + pFd -> fileListY > y)
		return(-1);
	
	/* ԖڂH */
	checkY = pFd->originY + pFd->fileListY + FD_CharHeight - 1;
	pFi = _FileDispTop;
	for (i = 0; i < FD_FilesInList; i++) {
		if (pFi == NULL)
			return(-1);	/* t@CȂ */
		if (y < checkY)
			return(i);	/* t@C */
		checkY += FD_CharHeight;
		pFi = pFi -> next;
	}
	return(-1);			/* t@CXgO */
}
/* ---	_checkFileList()  --- */


LOCAL	void
_reverseFileName(
	int		fileNo,		/* ]Ώۃt@Cԍ(擪0) */
	fileDialog_t	*pFd)
{
	DISP_xorRectangle(
		pFd->originX + pFd->fileListX,
		pFd->originY + pFd->fileListY + FD_CharHeight * fileNo,
		pFd->originX + pFd->fileListX + FD_CharWidth * (FnameLen+2) - 1,
		pFd->originY + pFd->fileListY + FD_CharHeight * (fileNo+1) - 1,
		0xffff);
}
/* ---	_reverseFileName()  --- */


LOCAL	void
_errorFatal(
	int	errorCode)
/*
 *	PURPOSE
 *		vIG[[`
 */
{
	longjmp(_FileDialogEnv, errorCode);
}
/* ---	_errorFatal()  --- */


/*****	filedlg.c  *****/
