        page    60,96
;
; EPSON GT-4000/6000 SCSI-I/F Handler
;           on 80386-Native Mode
;    Copyright 1990 by S.Unozawa
;
ScsiID  equ     6
Lun     equ     0
;
DAT     segment dword 'DATA'
DGROUP  group   DAT
        assume  ds:DGROUP
;
; SCSI-Device Information
;

;        extrn   ScsiID:dword    ; SCSI-ID No.
;        extrn   Lun:dword       ; Logical Unit Number
DAT     ends

codeseg segment dword 'CODE'
        assume  cs:codeseg
        extrn   Phase:near
        public  GT_Check
        public  GT_Init
        public  GT_SndCmd
        public  GT_SndCnt
        public  GT_RcvCnt
        public  GT_SndPrm
        public  GT_RcvDat
        db      'GT_SCSI',7

; Check Device
;  OUT: ax = 0 -> Check OK, else Not Ready or Not Connect
;
GT_Check proc near
        enter   24,0
        push    edi
        push    ebx
        push    ecx
        lea     edi,[ebp-18]    ; Set Parameter Address
        lea     ebx,[ebp-24]    ; Set CDB Address
; Inquiry
        mov     eax,Lun         ; Get LUN
        shl     al,5            ; Make LUN bit
        mov     ah,al
        mov     al,012h         ; SCSI Inquiry Command
        mov     [ebx],eax
        xor     ax,ax
        mov     al,04h          ; Get 4 Byte Inquiry Data
        mov     [ebx+4],ax      ; Set Byte & Flag
        mov     eax,ScsiID      ; Set SCSI-ID
        call    Phase           ; Go SCSI Phase
        cmp     cl,04h          ; 4 Byte Read ?
        mov     al,0ffh         ; Error Code
        jne     GT_Chk9         ; Error, Branch
        cmp     [edi],byte ptr 03h ; Processor Device ?
        jne     GT_Chk9         ; Branch, Not GT-4/6000 Scanner
        call    Rsense
	xor	eax,eax
GT_Chk9:
        pop     ecx
        pop     ebx
        pop     edi
        leave
        ret
GT_Check endp

; GT-4/6000 Initialize (Send ESC+@ Command)
;  OUT: ax = 0 -> Check OK, else Not Ready or Not Connect
;
GT_Init proc near
        mov     ah,'@'          ; ESC+@
        call    GT_SndCmd
        cmp     ax,2            ; 2 byte send ?
        jne     GT_Init8
        call    GT_RcvCnt       ; Receive 'ACK'
        cmp     al,06h          ; is 'ACK' ?
        jne     GT_Init8
        call    Rsense
        ret
GT_Init8:
        mov     ax,0ffffh       ; Initialize Fail
        ret
GT_Init endp

; Request Sense
;
RSense  proc    near
        enter   24,0
        push    edi
        push    ebx
        push    ecx
        lea     edi,[ebp-18]    ; Set Parameter Address
        lea     ebx,[ebp-24]    ; Set CDB Address
        mov     [ebx],byte ptr 03h ; SCSI Request Sense Command
        mov     [ebx+4],byte ptr 08h ; Get Sense Code 8 byte
        mov     eax,ScsiID      ; Set SCSI-ID
        call    Phase           ; Go SCSI Phase
        cmp     cl,08h          ; 8 Byte Read ?
        mov     al,0ffh         ; Error Code
        jne     Rsense8         ; Error, Branch
        xor     eax,eax         ; Clear, No Error
        jmp     Rsense9
Rsense8:
        mov     ax,0ffffh
Rsense9:
        pop     ecx
        pop     ebx
        pop     edi
        leave
        ret
RSense  endp

; Send GT-3/4/6000 Command
;  IN : ah = Command Char '?' (ESC+?)
;  OUT: ax = Send Byte
;
GT_SndCmd proc near
        enter   2,0
        push    edi
        push    ecx
        mov     al,01bh         ; ESC
        lea     edi,[ebp-2]     ; Set Parameter Address
        mov     [edi],ax        ; Set 'ESC+CMD'
        mov     cx,0002h        ; 2 Byte
        call    GT_SndPrm
        pop     ecx
        pop     edi
        leave
        ret
GT_SndCmd endp

; Send Control Code
;  IN : al = ACK(06h), CAN(18h), NAK(15h)
;
GT_SndCnt proc near
        enter   2,0
        push    edi
        push    ecx
        mov     ah,00h
        lea     edi,[ebp-2]     ; Set Parameter Address
        mov     [edi],ax        ; Set Parameter
        mov     cx,0001h        ; 1 Byte
        call    GT_SndPrm
        pop     ecx
        pop     edi
        leave
        ret
GT_SndCnt endp

; Receive Control Code from Scanner
;  OUT: al = ACK(06h), CAN(18h), NAK(15h)
;
GT_RcvCnt proc near
        enter   2,0
        push    edi
        push    ecx
        lea     edi,[ebp-2]     ; Set Parameter Address
        mov     cx,0001h        ; 1 Byte
        call    GT_RcvDat
        xor     eax,eax
        mov     al,[edi]
        pop     ecx
        pop     edi
        leave
        ret
GT_RcvCnt endp

; Send GT-3/4/6000 Parameters
;  IN : cx = Parameter Byte Count
;       es:edi = Parameter Pointer
;  OUT: ax = Send Byte
;
GT_SndPrm proc near
        enter   6,0
        push    ebx
        push    ecx
        lea     ebx,[ebp-6]     ; Set CDB Address
        mov     eax,Lun         ; Get LUN
        shl     al,5            ; Make LUN bit
        mov     ah,al
        mov     al,0ah          ; SCSI Write Command
        mov     [ebx],ax        ; Set Command & Lun
        xor     ax,ax
        mov     [ebx+2],ax      ; Clear Address Area
        mov     al,cl           ; Send Byte (Maybe Write Byte < 256)
        mov     [ebx+4],ax      ; Set Write Byte & Flag
        mov     eax,ScsiID
        call    Phase
        mov     eax,ecx
        pop     ecx
        pop     ebx
        leave
        ret
GT_SndPrm endp

; Receive Data Block from Scanner
;  IN : cx = Receive Data Byte Count
;       es:edi = Parameter Pointer
;  OUT: ax = Receive Byte
;
GT_RcvDat proc near
        enter   6,0
        push    edi
        push    ebx
        push    ecx
        lea     ebx,[ebp-6]     ; Set CDB Address
        mov     eax,Lun         ; Get LUN
        shl     al,5            ; Make LUN bit
        mov     ah,al
        mov     al,08h          ; SCSI Read Command
        mov     [ebx],ax        ; Set Command & Lun
        xor     ax,ax
        mov     [ebx+2],al      ; Clear Address Area
        mov     [ebx+3],ch      ; Set Higher Byte
        mov     [ebx+4],cl      ; Set Lower Byte
        mov     [ebx+5],al      ; Clear Lower Byte
        mov     eax,ScsiID
        call    Phase
        xor     eax,eax
        mov     ax,cx
        pop     ecx
        pop     ebx
        pop     edi
        leave
        ret
GT_RcvDat endp
;
codeseg ends
        end
