#include <stdio.h>
#include <stdlib.h>
#include <egb.h>
#include <mos.h>

#define ACK 0x06
#define STX 0x02

int  ScsiID, Lun;
char VRbuf[2048];   /* VRAM Line Buffer */
char SCbuf[4096];   /* SCanner Read Data Buffer */
char work[1536];
char mwork[4096];
/* Data Block Header */
struct GT_head {
     char stx;      /* STX */
     char stat;     /* Status */
     short byte;    /* Block Size */
};

/* Command Parameter Buffer */
/* Command Parameter Buffer */
union GT_Parm {
     char chr[8];
     short sht[4];
};
/* EGB Lib-Parameter */
struct EGB_Parm {
     char *addr;
     short seg;
     short x1;
     short y1;
     short x2;
     short y2;
     short x;
     short y;
};

extern int GT_Check();
extern void SndCmd();
extern void SndCnt();
extern void SndPrm();
extern char RcvCnt();
extern void RcvDat();
extern void GT2TOWN();
void setup();
void DrawLin(char *ptr, int lin, int cnt);
void comm(char com, void *ptr, int cnt);

void main()
{
     int  i, cnt, bot, mx, my;
     struct GT_head h;

     ScsiID = 6; Lun = 0;
     if (GT_Check() != 0) exit(0);
     setup();
     SndCmd('G');
     for ( i = 0; ; i++) {
          RcvDat(&h, 4); /* Read Header */
          if (h.stx != STX) break;
          cnt = (int)h.byte;
          RcvDat(SCbuf, cnt);
          GT2TOWN(SCbuf, VRbuf, 1024);
          DrawLin(VRbuf, i, 320);
          if ((h.stat & 0xe0) != 0) break;
          SndCnt(ACK);
     }
     do {
          MOS_rdpos( &bot, &mx, &my);
     } while (bot == 0);
     MOS_end();
}

void setup()
{
     union GT_Parm p;

/* Graphic VRAM Setup */
     EGB_init(work, 1536);
     EGB_resolution(work, 0, 10);
     EGB_displayPage(work, 0, 1);

/* Mouse Start */
     MOS_start(mwork, 4096);

/* GT-6000 Setup */
     p.chr[0] = 0x05; /* Set 5bit/pixel */
     comm('D', &p, 1);

     p.chr[0] = 0x00; /* Set Mono-Crome */
     comm('C', &p, 1);

     p.sht[0] = 75;  /* 100 * 100 DPI */
     p.sht[1] = 75;
     comm('R', &p, 4);

     p.sht[0] = 0;
     p.sht[1] = 0;
     p.sht[2] = 320;
     p.sht[3] = 240;
     comm('A', &p, 8);
}

void DrawLin(char *buf, int line, int cnt)
{
     struct EGB_Parm p;

     p.addr = buf;
     p.seg = 0x0014;
     p.x1 = 0;
     p.y1 = (short)line;
     p.x2 = (short)cnt;
     p.y2 = (short)line;
     p.x = (short)cnt;
     p.y = 1;
     EGB_putBlockZoom(work, 0, (char *)(&p));
}

void comm(char com, void *ptr, int cnt)
{
     SndCmd(com);
     if (RcvCnt() != ACK) return;
     SndPrm(ptr, cnt);
     if (RcvCnt() != ACK) return;
     return;
}
