/*
	program	fin.c

		usage : fin <*.pix> <time>
*/


#include	<stdio.h>
#include	<stdlib.h>
#include	"stella.h"
#include	"ioport.h"


#define		crtc			0x0440
#define		dummyreg		    30
#define		video_out_ctrl	0x0448
#define		priority		  0x01

#define		alg_pal			0xfd90
#define		blue_pal		0xfd92
#define		red_pal			0xfd94
#define		green_pal		0xfd96

#define		division			15


typedef	struct{
			int		r,
					g,
					b;
}		rgbty;


extern	void
		setpal(
			rgbty	pal[]
		),
		readpal(
			rgbty	pal[]
		),
		frdpal(
			rgbty	pal[],
			FILE	*file
		);
extern	int
		getw(
			FILE	*stream
		);


void
main(
	int		ac,
	char	**ag
){
	int		i,j,w,
			inter;
	char	*pixname;
	FILE	*pf;
	rgbty	spal[16],
			mpal[16],
			dpal[16];
	
	if(ac==1){
		puts("usage : fin <*.pix> <time> ");
		exit(1);
	}else{
		pixname = ag[1];
		inter   = atoi(ag[2]);
	}

	readpal(spal);

	pf = fopen(pixname,"rb");
	if(pf!=NULL){
		fseek(pf,10*sizeof(short),SEEK_SET);
		frdpal(dpal,pf);
		fclose(pf);

		for(i=0;i<=division;++i){
			for(j=0;j<16;++j){
				mpal[j].r = (i*dpal[j].r+(division-i)*spal[j].r)/division;
				mpal[j].b = (i*dpal[j].b+(division-i)*spal[j].b)/division;
				mpal[j].g = (i*dpal[j].g+(division-i)*spal[j].g)/division;
			}
			setpal(mpal);
			for(w=0;w<inter;++w);
		}
	}else{
		printf("can-t open %s \n",pixname);
	}
}


void
setpal(
	rgbty	pal[]
){
	int		i;

	enable16c();
	outrb(video_out_ctrl,priority,1|0x08);
										/* layer 0,16c pal /  adv layer 1 */
	while((inrw(crtc,dummyreg)&0x0400)==0);
	for(i=0;i<16;++i){
		outpb(alg_pal	,i);
		outpb(blue_pal	,pal[i].b<<4);
		outpb(red_pal	,pal[i].r<<4);
		outpb(green_pal	,pal[i].g<<4);
	}
}


void
readpal(
	rgbty	pal[]
){
	int		i;
		
	outrb(video_out_ctrl,priority,1|0x08);
										/* layer 0,16c pal /  adv layer 1 */
	for(i=0;i<16;++i){
		outpb(alg_pal,i);
		pal[i].b = inpb(blue_pal )>>4;
		pal[i].r = inpb(red_pal	 )>>4;
		pal[i].g = inpb(green_pal)>>4;
	}
}


void
frdpal(
	rgbty	pal[],
	FILE	*file
){
	int		p;

	for(p=0;p<16;++p){
		pal[p].r = getw(file);
		pal[p].g = getw(file);
		pal[p].b = getw(file);
	}
}		


int
getw(
	FILE	*stream
){
	int		wl,wh;
	
	wl = getc(stream);
	wh = getc(stream);

	return((wh<<8)+wl);
}
	

/*
	end of prog
*/
