/*
	program	pix.c
		
		for FM-Towns
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"stella.h"
#include	"ioport.h"


#define		hpck0		 0x00
#define		hpck1		 0x10
#define		hpck2		 0x20
#define		hpck3		 0x30
#define		hpck4		 0x40

#define		backmax		   16

#define		vram			0x0120
#define		phys			0x0060
#define		vram_acc		0x0458
#define		orgofs			     0
#define		xwbyte			   320

#define		video_out_ctrl	0x0448
#define		priority		  0x01

#define		alg_pal			0xfd90
#define		blue_pal		0xfd92
#define		red_pal			0xfd94
#define		green_pal		0xfd96

#define		rdiv(a,b)		(((a)+(b)/2)/(b))


typedef	struct{
			int		h,
					s,
					v;
}		hsvty;

typedef	struct{
			int		r,
					g,
					b;
}		rgbty;


static	int		backlim  = 16;
static	char	*plane[4];
static	hsvty	palx[16];
static	rgbty	pal [16] = 	{
								{ 0, 0, 0},
								{ 0, 0,12},
								{12, 0, 0},
								{12, 0,12},
								{ 0,12, 0},
								{ 0,12,12},
								{12,12, 0},
								{12,12,12},
								{ 0, 0, 0},
								{ 0, 0,12},
								{12, 0, 0},
								{12, 0,12},
								{ 0,12, 0},
								{ 0,12,12},
								{12,12, 0},
								{12,12,12},
							};


extern	int
		svpix(
			int		x0,
			int		y0,
			int		x1,
			int		y1,
			char	*filename,
			rgbty	pal[]
		);
extern	void
		lpck1(
			char	*vptr,
			int		xw,
			char	*buf0,
			int		*siz
		),
		lpck2(
			char	*vptr,
			int		xw,
			char	*vptrp,
			int		*siz
		),
		lpck3(
			char	*vptr,
			int		xw,
			char	*vptr0,
			char	*buf0,
			int		*siz
		),
		lpck4(
			char	*vptr,
			int		xw,
			char	*vptr0,
			char	*buf0,
			int		*siz
		);
extern	int
		ldpix(
			char	*filename,
			rgbty	pal[]
		),
		ldpixto(
			int		x0,
			int		y0,
			char	*filename,
			rgbty	pal[]
		);
extern	void
		lunpck1(
			char	*vptr,
			int		xw,
			char	*buf,
			int		*siz
		),
		lunpck3(
			char	*vptr,
			int		xw,
			char	*vptr0,
			char	*buf,
			int		*siz
		),
		lunpck4(
			char	*vptr,
			int		xw,
			char	*vptr0,
			char	*buf,
			int		*siz
		);
extern	void
		frdpal(
			rgbty	pal[],
			FILE	*file
		),
		fwrpal(
			rgbty	pal[],
			FILE	*file
		),
		mkplane(
			char	*plane[]
		),
		rsplane(
			char	*plane[]
		);
extern	int
		ldpal(
			char	*name,
			hsvty	palx[]
		);
extern	void
		rdpal(
			FILE	*algfile,
			hsvty	pal[]
		);
extern	int
		getw(
			FILE	*stream
		),
		putw(
			int		w,
			FILE	*stream
		);
extern	void
		torgb(
			hsvty	pal[],
			rgbty	pal2[]
		),
		setpal(
			rgbty	pal[]
		);


void
main(
	int		ac,
	char	*ag[]
){
	int		x0,y0,x1,y1;
	char	*name,
			*algname;

	if(ac==1){
		printf("--- Heart Beat Graphical Loader / Saver v1.1 --- \n");
		printf("\n");
		printf("                             for FM-Towns");
		printf("\n");
		printf("Usage : pix [-l{n} <file.pix> {<x0> <y0>} | \n");
		printf("             -s{q} <file.pix> {<x0> <y0> <x1> <y1>} {<file.alg>}] \n");
		exit(1);
	}else{
		name = ag[2];
	}

	if(seq(ag[1],"-l") or seq(ag[1],"-ln")){
		if(ac!=5){
			ldpix(name,pal);
		}else{
			x0 = atoi(ag[3]);
			y0 = atoi(ag[4]);
			ldpixto(x0,y0,name,pal);
		}
		if(seq(ag[1],"-l")){
			setpal(pal);
		};
	};

	if(seq(ag[1],"-s") or seq(ag[1],"-sq")){
		if(seq(ag[1],"-sq"))	backlim =  4;;
		if(seq(ag[1],"-s" ))	backlim = 16;;
		x0 =   0;
		y0 =   0;
		x1 = 639;
		y1 = 399;
		if(7<=ac){
			x0 = atoi(ag[3]);
			y0 = atoi(ag[4]);
			x1 = atoi(ag[5]);
			y1 = atoi(ag[6]);
		};

		if(ac==4)	algname = ag[3];;
		if(ac==8)	algname = ag[7];;
		if(ac==4 || ac==8){
			ldpal(algname,palx);
			torgb(palx,pal);
		};
		svpix(x0,y0,x1,y1,name,pal);
	};
}


int
svpix(
	int		x0,
	int		y0,
	int		x1,
	int		y1,
	char	*filename,
	rgbty	pal[]
){
	int		rc,
			xw,yw,
			s,y;
	FILE	*file;
	char	*buff,
			*bptr,
			*vptr;
	short	*hptr;
	int		pcktyp,
			pcksiz;
	void	*pckbuf;
	int		pck1siz,
			pck3siz,
			pck4siz;
	char	pck1buf         [160],
			pck3buf[backmax][160],
			pck4buf[backmax][160];
	int		i,
			backline;

	rc   = 0;
	xw   = x1/8-x0/8+1;
	yw   = y1-y0+1;

	file = fopen(filename,"wb");
	if(file!=NULL){
		mkplane(plane);
		buff  = malloc(81*400);

		hptr    = (short*)buff;
		hptr[0] =  1;
		hptr[1] = x0;
		hptr[2] = y0;
		hptr[3] = xw;
		hptr[4] = yw;
		hptr[5] =  4;
		hptr[6] =  0;
		hptr[7] =  0;
		hptr[8] =  0;
		hptr[9] =  0;
		fwrite(hptr,sizeof(short),10,file);
		fwrpal(pal,file);

		for(s=0;s<4;++s){
			bptr = buff;
			vptr = plane[s]+(80*y0+x0/8);
			for(y=y0;y<=y1;++y){
				pcktyp = hpck0;
				pcksiz = xw;
				pckbuf = vptr;

				if(y-y0<backlim)	backline = y-y0;
					else			backline = backlim;

				lpck1(vptr,xw,pck1buf,&pck1siz);
				if(pck1siz<pcksiz){
					pcktyp = hpck1;
					pcksiz = pck1siz;
					pckbuf = pck1buf;
				};

				for(i=1;i<=backline;++i){
					lpck3(vptr,xw,vptr-80*i,pck3buf[i-1],&pck3siz);
					if(pck3siz<pcksiz){
						pcktyp = hpck3+(i-1);
						pcksiz = pck3siz;
						pckbuf = pck3buf[i-1];
					};
				}

				for(i=1;i<=backline;++i){
					lpck4(vptr,xw,vptr-80*i,pck4buf[i-1],&pck4siz);
					if(pck4siz<pcksiz){
						pcktyp = hpck4+(i-1);
						pcksiz = pck4siz;
						pckbuf = pck4buf[i-1];
					};
				}

				*(bptr++) = pcktyp;
				memcpy(bptr,pckbuf,pcksiz);
				bptr += pcksiz;
				vptr += 80;
			}
			fwrite(buff,bptr-buff,1,file);
			fseek(file,(s+6)*sizeof(short),SEEK_SET);
			hptr  = (short*)buff;
			*hptr = bptr-buff;
			fwrite(buff,sizeof(short),1,file);
			fseek(file,0,SEEK_END);
		}
		rsplane(plane);
		free(buff);
		fclose(file);
	}else{
		rc = 1;
	}
	return(rc);
}


void
lpck1(
	char	*vptr,
	int		xw,
	char	*buf0,
	int		*siz
){
	int		x,
			ct,
			dat;
	char	*buf;

	buf = buf0;
	x   = 0;
	while(x<xw){
		dat = *(vptr++);
		ct  = 1;
		++x;
		while(x<xw && *vptr==dat){
			++vptr;
			++ct;
			++x;
		}
		*(buf++) = ct;
		*(buf++) = dat;
	}
	*siz = buf-buf0;
}


void
lpck2(
	char	*vptr,
	int		xw,
	char	*vptrp,
	int		*siz
){
	int		i;

	i = 0;
	while(i<xw && *vptr==*vptrp){
		++i;
		++vptr;
		++vptrp;
	}
	if(i==xw){
		*siz =  0;
	}else{
		*siz = 80;
	}
}


void
lpck3(
	char	*vptr,
	int		xw,
	char	*vptr0,
	char	*buf0,
	int		*siz
){
	char	*buf;
	int		i,
			ct;

	buf = buf0;
	i   = 0;
	while(i<xw){
		ct = 0;
		while(i<xw && *vptr==*vptr0){
			++ct;
			++vptr;
			++vptr0;
			++i;
		}
		*(buf++) = ct;

		if(i<xw){
			*(buf++) = *(vptr++);
			++vptr0;
			++i;
		};
	}
	*siz = buf-buf0;
}


void
lpck4(
	char	*vptr,
	int		xw,
	char	*vptr0,
	char	*buf0,
	int		*siz
){
	char	*buf,
			*vptrx;
	int		i,
			ct;

	buf = buf0;
	i   = 0;
	while(i<xw){
		ct = 0;
		while(i<xw && *vptr==*vptr0){
			++ct;
			++vptr;
			++vptr0;
			++i;
		}
		*(buf++) = ct;

		if(i<xw){
			ct    = 0;
			vptrx = vptr;
			while(i<xw && *vptrx!=*vptr0){
				++ct;
				++vptrx;
				++vptr0;
				++i;
			}
			*(buf++) = ct;
			memcpy(buf,vptr,ct);
			buf     += ct;
			vptr     = vptrx;
		};
	}
	*siz = buf-buf0;
}


int
ldpix(
	char	*filename,
	rgbty	pal[]
){
	int		rc;
	FILE	*file;
	int		x0,y0,
			xw,yw,
			y1,s,y,
			pcktyp,
			backline,
			siz;
	char	*buff,
			*bptr,
			*vptr;
	short	hptr[10];
	long	allsiz;

	rc   = 0;
	file = fopen(filename,"rb");
	if(file!=NULL){
		mkplane(plane);
		fread(hptr,sizeof(short ),10,file);
		frdpal(pal,file);
		x0     = hptr[1];
		y0     = hptr[2];
		xw     = hptr[3];
		yw     = hptr[4];
		y1     = y0+yw-1;
		allsiz = (unsigned long)hptr[6]
				+(unsigned long)hptr[7]
				+(unsigned long)hptr[8]
				+(unsigned long)hptr[9];

		buff = malloc((unsigned)allsiz);
		fread(buff,(unsigned)allsiz,1,file);
		bptr = buff;

		for(s=0;s<4;++s){
			vptr = plane[s]+(80*y0+x0/8);
			for(y=y0;y<=y1;++y){
				pcktyp   = *(bptr++);
				backline = (pcktyp & 0x0f)+1;
				switch(pcktyp & 0xf0){
					case hpck0:
						memcpy(vptr,bptr,xw);
						bptr += xw;
						break;
					case hpck1:
						lunpck1(vptr,xw,bptr,&siz);
						bptr += siz;
						break;
					case hpck2:
						memcpy(vptr,vptr-80*backline,xw);
						break;
					case hpck3:
						lunpck3(vptr,xw,vptr-80*backline,bptr,&siz);
						bptr += siz;
						break;
					case hpck4:
						lunpck4(vptr,xw,vptr-80*backline,bptr,&siz);
						bptr += siz;
						break;
					;
				}
				vptr += 80;
			}
		}
		free(buff);
		fclose(file);
		rsplane(plane);
	}else{
		rc = 1;
	}
	return(rc);
}


int
ldpixto(
	int		x0,
	int		y0,
	char	*filename,
	rgbty	pal[]
){
	int		rc;
	FILE	*file;
	int		xw,yw,
			y1,s,y,
			pcktyp,
			backline,
			siz;
	char	*buff,
			*bptr,
			*vptr;
	short	hptr[10];
	long	allsiz;

	rc   = 0;
	file = fopen(filename,"rb");
	if(file!=NULL){
		mkplane(plane);
		fread(hptr,sizeof(short ),10,file);
		frdpal(pal,file);
		xw     = hptr[3];
		yw     = hptr[4];
		y1     = y0+yw-1;
		allsiz = (unsigned long)hptr[6]
				+(unsigned long)hptr[7]
				+(unsigned long)hptr[8]
				+(unsigned long)hptr[9];

		buff = malloc((unsigned)allsiz);
		fread(buff,(unsigned)allsiz,1,file);
		bptr = buff;

		for(s=0;s<4;++s){
			vptr = plane[s]+(80*y0+x0/8);
			for(y=y0;y<=y1;++y){
				pcktyp   = *(bptr++);
				backline = (pcktyp & 0x0f)+1;
				switch(pcktyp & 0xf0){
					case hpck0:
						memcpy(vptr,bptr,xw);
						bptr += xw;
						break;
					case hpck1:
						lunpck1(vptr,xw,bptr,&siz);
						bptr += siz;
						break;
					case hpck2:
						memcpy(vptr,vptr-80*backline,xw);
						break;
					case hpck3:
						lunpck3(vptr,xw,vptr-80*backline,bptr,&siz);
						bptr += siz;
						break;
					case hpck4:
						lunpck4(vptr,xw,vptr-80*backline,bptr,&siz);
						bptr += siz;
						break;
					;
				}
				vptr += 80;
			}
		}
		free(buff);
		fclose(file);
		rsplane(plane);
	}else{
		rc = 1;
	}
	return(rc);
}


void
lunpck1(
	char	*vptr,
	int		xw,
	char	*buf,
	int		*siz
){
	int		x,
			ct,
			dat;
	char	*bptr;

	bptr = buf;
	x    = 0;
	while(x<xw){
		ct  = * bptr;
		dat = *(bptr+1);
		memset(vptr,dat,ct);
		bptr += 2;
		vptr += ct;
		x    += ct;
	}
	*siz = bptr-buf;
}


void
lunpck3(
	char	*vptr,
	int		xw,
	char	*vptr0,
	char	*buf0,
	int		*siz
){
	int 	i,
			ct;
	char	*buf;

	buf = buf0;
	i   = 0;
	while(i<xw){
		ct = *(buf++);
		memcpy(vptr,vptr0,ct);
		vptr  += ct;
		vptr0 += ct;
		i     += ct;

		if(i<xw){
			*(vptr++) = *(buf++);
			++vptr0;
			++i;
		};
	}
	*siz = buf-buf0;
}


void
lunpck4(
	char	*vptr,
	int		xw,
	char	*vptr0,
	char	*buf0,
	int		*siz
){
	int 	i,
			ct;
	char	*buf;

	buf = buf0;
	i   = 0;
	while(i<xw){
		ct = *(buf++);
		memcpy(vptr,vptr0,ct);
		vptr  += ct;
		vptr0 += ct;
		i     += ct;

		if(i<xw){
			ct = *(buf++);
			memcpy(vptr,buf,ct);
			vptr  += ct;
			vptr0 += ct;
			buf   += ct;
			i     += ct;
		};
	}
	*siz = buf-buf0;
}


/*-------------------------------------------------------------*/


void
frdpal(
	rgbty	pal[],
	FILE	*file
){
	int		p;

	for(p=0;p<16;++p){
		pal[p].r = getw(file);
		pal[p].g = getw(file);
		pal[p].b = getw(file);
	}
}		


void
fwrpal(
	rgbty	pal[],
	FILE	*file
){
	int		p;
	
	for(p=0;p<16;++p){
		putw(pal[p].r,file);
		putw(pal[p].g,file);
		putw(pal[p].b,file);
	}
}


void
mkplane(
	char	*plane[]
){
	char	*b1p,*r1p,*g1p,*e1p;
	int		bdat,
			b1d,r1d,g1d,e1d,
			i,j;
				
	plane[0] = malloc(32000);
	plane[1] = malloc(32000);
	plane[2] = malloc(32000);
	plane[3] = malloc(32000);
				
	b1p = plane[0];
	r1p = plane[1];
	g1p = plane[2];
	e1p = plane[3];
	
	for(i=0;i<128000;i+=4){
		bdat = peekdx(vram,i);

		b1d = 0;
		r1d = 0;
		g1d = 0;
		e1d = 0;
				
		for(j=0;j<8;++j){
			b1d    = b1d<<1 | bdat&1;
			bdat >>= 1;
			r1d    = r1d<<1 | bdat&1;
			bdat >>= 1;
			g1d    = g1d<<1 | bdat&1;
			bdat >>= 1;
			e1d    = e1d<<1 | bdat&1;
			bdat >>= 1;
		}

		*(b1p++) = b1d;
		*(r1p++) = r1d;
		*(g1p++) = g1d;
		*(e1p++) = e1d;
	}
}


void
rsplane(
	char	*plane[]
){
	int		i,j,
			vptr;
	char	*b1p,*r1p,*g1p,*e1p;

	outregw(vram_acc,0,0xffff);
	outregw(vram_acc,1,0xffff);

	b1p  = plane[0];
	r1p  = plane[1];
	g1p  = plane[2];
	e1p  = plane[3];

	vptr = orgofs;
	for(j=0;j<400;++j){
		for(i=0;i<80;++i){
			pokedx(vram,vptr,	 tob16c[*e1p]<<3
								|tob16c[*g1p]<<2
								|tob16c[*r1p]<<1
								|tob16c[*b1p]   );
			++b1p;
			++r1p;
			++g1p;
			++e1p;
			vptr += 4;
		}
		vptr += xwbyte-320;
	}

	free(plane[0]);
	free(plane[1]);
	free(plane[2]);
	free(plane[3]);
}


int
ldpal(
	char	*name,
	hsvty	palx[]
){
	int		rc;
	FILE	*af;

	rc = 0;
	af = fopen(name,"rb");
	if(af!=NULL){
		rdpal (af,palx);
		fclose(af);
	}else{
		rc = 1;
	}
	return(rc);
}


void
rdpal(
	FILE	*algfile,
	hsvty	pal[]
){
	int		i;

	pal[0].h = getw(algfile);
	for(i=9;i<=15;++i){
		pal[i].h = getw(algfile);
	}
	pal[0].s = getw(algfile);
	for(i=9;i<=15;++i){
		pal[i].s = getw(algfile);
	}
	pal[0].v = getw(algfile);
	for(i=9;i<=15;++i){
		pal[i].v = getw(algfile);
	}

	pal[8].h = getw(algfile);
	for(i=1;i<=7;++i){
		pal[i].h = getw(algfile);
	}
	pal[8].s = getw(algfile);
	for(i=1;i<=7;++i){
		pal[i].s = getw(algfile);
	}
	pal[8].v = getw(algfile);
	for(i=1;i<=7;++i){
		pal[i].v = getw(algfile);
	}
}


int
getw(
	FILE	*stream
){
	int		wl,wh;
	
	wl = getc(stream);
	wh = getc(stream);

	return((wh<<8)+wl);
}
	

int
putw(
	int		w,
	FILE	*stream
){
	putc((w   )& 0xff,stream);
	putc((w>>8)& 0xff,stream);

	return(w);
}
	

void
torgb(
	hsvty	pal[],
	rgbty	pal2[]
){
	int		imax = 15;
	int		p;
	long	h,s,v,i,f,m,n,k,r,g,b;

	for(p=0;p<16;++p){
		h = pal[p].h;			/* 1/360 */
		s = pal[p].s;			/* 1/100 */
		v = pal[p].v;			/* 1/100 */

		i = h/60;
		f = h-60*i;				/* 1/60 */
		m = v*(100-s);			/* 1/10000 */
		n = v*(6000-s*f);		/* 1/600000 */
		k = v*(6000-s*(60-f));	/* 1/600000 */

		switch((int)i){
			case 0:
				r = rdiv(imax*v,   100L);
				g = rdiv(imax*k,600000L);
				b = rdiv(imax*m, 10000L);
				break;
			case 1:
				r = rdiv(imax*n,600000L);
				g = rdiv(imax*v,   100L);
				b = rdiv(imax*m, 10000L);
				break;
			case 2:
				r = rdiv(imax*m, 10000L);
				g = rdiv(imax*v,   100L);
				b = rdiv(imax*k,600000L);
				break;
			case 3:
				r = rdiv(imax*m, 10000L);
				g = rdiv(imax*n,600000L);
				b = rdiv(imax*v,   100L);
				break;
			case 4:
				r = rdiv(imax*k,600000L);
				g = rdiv(imax*m, 10000L);
				b = rdiv(imax*v,   100L);
				break;
			case 5:
				r = rdiv(imax*v,   100L);
				g = rdiv(imax*m, 10000L);
				b = rdiv(imax*n,600000L);
				break;
		}

		pal2[p].r = (int)r;
		pal2[p].g = (int)g;
		pal2[p].b = (int)b;
	}
}


void
setpal(
	rgbty	pal[]
){
	int		i;

	enable16c();
	outregb(video_out_ctrl,priority,1|0x08);
										/* layer 0,16c pal /  adv layer 1 */
	for(i=0;i<16;++i){
		outpb(alg_pal	,i);
		outpb(blue_pal	,pal[i].b<<4);
		outpb(red_pal	,pal[i].r<<4);
		outpb(green_pal	,pal[i].g<<4);
	}
}


/*
	end of prog
*/
