/*
	program mkp16.c
	
	make *.p16 (640*480) <= *.tif (640*480) + *.p0f
	
	usage : mkp16 tif&p0f_name
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

char	p16h[]	={ 
		   0x59,0x55,0x4b,0x49,0xff,0xff,0xff,0xff, /* 00 */
		   0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		   
		   0x01,0x00,0x03,0x00,0x00,0x00,0x00,0x00, /* 01 */
		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

   		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, /* 02 */
		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, /* 03 */
		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, /* 04 */
		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, /* 05 */
		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, /* 06 */
		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

		   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, /* 07 */
		   0x00,0x00,0x00,0x58,0x02,0x00,0x00,0x00,

		   0x00,0x00,0x7f,0x02,0xdf,0x01            /* 08 */
		};


void	main (  int ac,   char *ag[] )
{
	FILE	*p16af, *tifaf, *p0faf;
	char	fbuf[320];
	char	p16name[20] ,tifname[20], p0fname[20];
	int	i;

	if ( ac == 1 )
	  {
		puts ( " usage : mkp16 tif&p16_name " );
		exit(1);
	  }
	strcpy ( p16name, ag[1] );
	strcpy ( tifname, ag[1] );
	strcpy ( p0fname, ag[1] );
	strcat ( p16name, ".p16" );
	strcat ( tifname, ".tif" );
	strcat ( p0fname, ".p0f" );

	p16af = fopen ( p16name,"wb" );
	tifaf = fopen ( tifname,"rb" );
	p0faf = fopen ( p0fname,"rb" );
	if ( ( p16af == NULL ) || ( tifaf == NULL ) ||
	     ( p0faf == NULL ) )
	  {
		exit(1);
	  }

	fread ( fbuf, 96, 1, p0faf );
	for ( i=0; i<96; i++ )
	  {
		p16h[i+24] = fbuf[i];
	  }
	fwrite ( p16h, 134, 1, p16af );

	for ( i=0; i<2; i++ )
	  {
		fread ( fbuf, 256, 1, tifaf );
	  }

	for ( i=0; i<480; i++ )
	  {
		fread  ( fbuf, 320, 1, tifaf );
		fwrite ( fbuf, 320, 1, p16af );
	  }

	fclose ( p0faf );
	fclose ( tifaf );
	fclose ( p16af );
}

/*	end of prog      */

