/*******************************************************

    EUP Code to MML Text Code Cnverter

    1990.8.13   Make by Ken

********************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <stdarg.h>
#include    <string.h>
#include    <ctype.h>

#define TRUE    1
#define FALSE   0
#define ERR     (-1)

#define UCHAR   unsigned char

#define DEF_Qn      7
#define DEF_OCT     ((4+1)*12)
#define DEF_VOL     64

#define MAX_TRK     16
#define MAX_BUF     (1024*256)

/*
#define CALC_MEAS(p) (p < btm_ptr ? cnv_14(p+2):384)
*/
#define CALC_MEAS(p) (384)

typedef struct _MML {
    struct _MML *next;
    char        *part[MAX_TRK];
} MMLPTR;

static int  MP_FLG=FALSE;
static int  now_q_time = DEF_Qn;
static int  now_oct = DEF_OCT;
static int  now_vol = 64;
static char *tmp_ptr=NULL;
static char tmp_buf[BUFSIZ];
static struct {
        char    *str;
        int     val;
    } onpu[]={
                                         { "1"  ,384 },
        { "2."  ,288 },                  { "2"  ,192 },
        { "4."  ,144 },  { "3"  ,128 },  { "4"  , 96 },
        { "8."  , 72 },  { "6"  , 64 },  { "8"  , 48 },
        { "16." , 36 },  { "12" , 32 },  { "16" , 24 },
        { "32." , 18 },  { "24" , 16 },  { "32" , 12 },
        { "64." ,  9 },  { "48" ,  8 },  { "64" ,  6 },
                         { "96" ,  4 },  { "128",  3 },
                         { "192",  2 },
                         { "384",  1 },
        { NULL,0    } };

static long int size=0;
static UCHAR    tempo=0;
static UCHAR    signa=0;
static int      fst_trk=(-1);
static UCHAR    *btm_ptr=NULL;
static UCHAR    eup_buf[MAX_BUF];

void	dsp_msg(form,...)
char    *form;
{
    va_list arg;

    va_start(arg,form);
    vfprintf(stderr,form,arg);
}

void	*xmalloc(s)
int	s;
{
    register void *p;

    if ( (p = (void *)malloc(s)) != NULL )
	return p;

    dsp_msg("Memory Alloc Error Abort...\n");
    exit(10);
}

/*
#define      strapn  printf
*/
void    strapn(form,...)
char    *form;
{
    va_list arg;
    char    dmy[80];
    register char *p;

    va_start(arg,form);
    vsprintf(dmy,form,arg);
    for ( p = dmy ; *p != '\0' && tmp_ptr < &tmp_buf[BUFSIZ-1] ; )
        *(tmp_ptr++) = *(p++);
    *tmp_ptr = '\0';
}

char    *strdup(str)
char    *str;
{
    register char *p;

    if ( (p = (char *)xmalloc(strlen(str)+1)) != NULL )
        strcpy(p,str);
    return p;
}

int     cnv_16(p)
register UCHAR  *p;
{
    int     i;

    i = p[3];
    i = i * 16 + p[2];
    i = i * 16 + p[1];
    i = i * 16 + p[0];
    return i;
}

int     cnv_14(p)
register UCHAR  *p;
{
    int     i;

    i = p[1];
    i = i * 128 + p[0];
    return i;
}

void    step_time(oct,st)
char    *oct;
int     st;
{
    int     i;

    for ( i = 0 ; st > 0 && onpu[i].str != NULL ; i++ ) {
        while ( st >= onpu[i].val ) {
            st -= onpu[i].val;
            strapn("%s%s%s",oct,onpu[i].str,(st > 0 ? "&":""));
        }
    }
}

int     gate_time(oct,gt)
char    *oct;
int     gt;
{
    int     i,n,m,q;

    for ( q = 0 ; onpu[q].str != NULL ; q++ ) {
        if ( onpu[q].val < 24 ) {
	    m = 0;
	    break;
	}

        if ( gt == (m = onpu[q].val * now_q_time / 8) ) {
            strapn("%s%s",oct,onpu[q].str);
	    return onpu[q].val;
	}

        if ( MP_FLG == FALSE ) {
	    for ( n = 0 ; onpu[n].val >= 24 ; n++ ) {
		if ( (gt % onpu[n].val) == m )
		    goto NEXT;
	    }

        } else {
	    for ( n = 0 ; onpu[n].val >= 24 ; n++ ) {
                if ( ((gt - 1) % (onpu[n].val - 1)) == (m - 1) ) {
		    gt += ((gt - 1) / (onpu[n].val - 1));
		    goto NEXT;
		}
	    }
        }
    }
NEXT:

    for ( n = i = 0 ; onpu[i].str != NULL ; i++ ) {

        while ( (gt - onpu[i].val) > m ) {
            gt -= onpu[i].val;
            n += onpu[i].val;
            strapn("%s%s&",oct,onpu[i].str);
            if ( MP_FLG != FALSE && gt > 0 && onpu[i].val > 1 && m == 0 )
		gt++;
        }

        if ( gt <= 0 )
            break;

        else if ( gt == onpu[i].val ) {
            n += onpu[i].val;
            if ( now_q_time != 8 )
                strapn("Q8%s%sQ%d",oct,onpu[i].str,now_q_time);
            else
                strapn("%s%s",oct,onpu[i].str);
            break;

        } else if ( gt == m ) {
            n += onpu[q].val;
            strapn("%s%s",oct,onpu[q].str);
            break;

        } else if ( gt == ((onpu[i].val * now_q_time) / 8) ) {
            n += onpu[i].val;
            strapn("%s%s",oct,onpu[i].str);
            break;
        }
    }
    return n;
}

char    *get_onpu(ot,vol)
int     ot,vol;
{
    static char *ot_tbl[]={
        "C","C#","D","D#","E","F","F#","G","G#","A","A#","B" };

    while ( ot < now_oct ) {
        strapn("<");
        now_oct -= 12;
    }

    while ( ot >= (now_oct + 12) ) {
        strapn(">");
        now_oct += 12;
    }

    vol &= 0x78;
    if ( vol != now_vol ) {
        strapn("V%-d",vol >> 3);
        now_vol = vol;
    }

    return ot_tbl[ot - now_oct];
}

int     chk_q_time(st,gt)
int     st,gt;
{
    int     i;

    i = gt * 8 / st;

    if ( i != now_q_time ) {
        if ( gt == (st * i / 8) && i > 4 && i <= 10 ) {
            now_q_time = i;
            strapn("Q%d",i);
        }
    }

    return now_q_time;
}

MMLPTR  *new_mml(mml,trk)
register MMLPTR *mml;
int     trk;
{
    int     i;

    if ( mml->next == NULL ) {
        if ( (mml->next = (MMLPTR *)xmalloc(sizeof(MMLPTR))) == NULL )
            exit(1);
        mml = mml->next;
        mml->next = NULL;
        for ( i = 0 ; i < MAX_TRK ; i++ )
            mml->part[i] = NULL;
    } else
        mml = mml->next;

#ifdef  BASIC
    mml->part[trk] = strdup(tmp_buf);
#else
    if ( strcmp(tmp_buf,"R1") != 0 )
        mml->part[trk] = strdup(tmp_buf);
#endif

    tmp_ptr = tmp_buf;
    tmp_buf[0] = '\0';

    return mml;
}

UCHAR   *next_noto(ptr,trk)
UCHAR   *ptr;
int     trk;
{
    while ( ptr < btm_ptr ) {
        if ( (ptr[0] & 0xF0) == 0x90 && ptr[1] == trk &&
             (ptr[6] & 0xF0) == 0x80 )
            return ptr;
        ptr += 6;
    }
    return ptr;
}

UCHAR   *next_meas(ptr)
UCHAR   *ptr;
{
    while ( ptr < btm_ptr ) {
        if ( *ptr == 0xF2 || *ptr == 0xFE )
            return ptr;
        ptr += 6;
    }
    return ptr;
}

char    *gene_mml(ptr,trk)
UCHAR   *ptr;
int     trk;
{
    int     cm;
    UCHAR   *p;
    static char dmy[32];

    dmy[0] = '\0';

    if ( ((cm = *ptr) & 0xF0) != 0xF0 )
        cm &= 0xF0;

    switch(cm) {
    case 0xB0:              /* Control Cheng */
        if ( trk == ptr[1] && ptr[4] == 0x0A ) {
            if ( 60 <= ptr[5] && ptr[5] <= 67 )
                strcpy(dmy,"%C");
            else if ( ptr[5] > 64 )
                sprintf(dmy,"%%R%-d",(ptr[5]-64)/4);
            else
                sprintf(dmy,"%%L%-d",(63-ptr[5])/4);
        }
        break;

    case 0xC0:              /* Program Cheng */
        if ( trk == ptr[1] )
            sprintf(dmy,"@%-d",ptr[4]+1);
        break;

    case 0xE0:              /* Pich Bend */
        if ( trk == ptr[1] )
            sprintf(dmy,"U%-d",(cnv_14(ptr+4)-8192));
        break;

    case 0xF8:              /* Tempo Cheng */
        for ( p = ptr + 6 ; p < btm_ptr ; p += 6 ) {
            if ( (*p & 0xF0) != 0xF0 )
                break;
        }
        if ( p < btm_ptr && p[1] == trk && tempo != cnv_14(ptr+4) ) {
            sprintf(dmy,"T%-d",cnv_14(ptr+4)+30);
            tempo = cnv_14(ptr+4);
        }
        break;
    }

    return (dmy[0] == '\0' ? NULL : dmy);
}

void    cnv_mml(ptr,mml,trk)
UCHAR   *ptr;
MMLPTR  *mml;
int     trk;
{
    int     s,n,fg;
    int     tick,ntick,step,gate,base,maxs;
    char    *onpu,*p;
    UCHAR   *mptr,*optr,*nptr;

    if ( (nptr = next_noto(ptr,trk)) >= btm_ptr )
        return;

    now_q_time = DEF_Qn;
    now_oct = DEF_OCT;
    now_vol = DEF_VOL;

    tmp_ptr = tmp_buf;
    tmp_buf[0] = '\0';

    strapn("Q7");
    if ( fst_trk < 0 )
        fst_trk = trk;

    mptr = next_meas(ptr);
    fg = FALSE;

    while ( ptr < btm_ptr ) {

        if ( fg != FALSE ) {
            nptr = next_noto(ptr+6,trk);
            tick = cnv_14(ptr+2);
            gate = cnv_16(ptr+7) + 1;
            onpu = get_onpu(ptr[4],ptr[5]);

        } else {
            tick = 0;
            gate = (-1);
            onpu = "R";
            fg = TRUE;
        }

        base = 0;
        maxs = CALC_MEAS(mptr);
        optr = mptr;

        for ( ; ; ) {
            if ( ptr == nptr || (p = gene_mml(ptr,trk)) != NULL ) {
                ntick = base + cnv_14(ptr+2);
                step = ntick - tick;

                while ( step > 0 ) {
                    if ( (tick + step) > maxs )
                        s = maxs - tick;
                    else
                        s = step;

                    if ( gate > s ) {
                        step_time(onpu,s);
                        strapn("&");
                        gate -= s;
                        if ( MP_FLG != FALSE && gate > 0 ) gate++;

                    } else if ( gate > 0 ) {
                        chk_q_time(s,gate);
                        n = gate_time(onpu,gate);
                        step_time("R",s-n);
                        gate = (-1);

                    } else
                        step_time("R",s);

                    tick += s;
                    step -= s;

                    if ( step > 0 || tick >= maxs ) {
                        optr = next_meas(optr+6);
                        maxs += CALC_MEAS(optr);

                        mml = new_mml(mml,trk);
                    }
                }

                if ( ptr != nptr )
                    strapn("%s",p);

                if ( ptr == nptr )
                    break;

                base = 0;
                maxs = CALC_MEAS(mptr);
                optr = mptr;

                tick = cnv_14(ptr+2);
            }
            ptr += 6;
            while ( ptr > mptr ) {
                base += CALC_MEAS(mptr);
                mptr = next_meas(mptr+6);
            }
        }
    }

    if ( tmp_buf[0] != '\0' )
        new_mml(mml,trk);
}
void    main(argc,argv)
int     argc;
char    *argv[];
{
    int     i,meas,no;
    MMLPTR  dmy;
    MMLPTR  *mml;
    FILE    *fp;
    char    *p;
    char    *eupfile=NULL;
    char    *ponfile=NULL;
    char    fmfile[10];
    char    pcmfile[10];
    char    part_ch[14];
    char    title[36];
    char    dmy_eup[80];
    char    dmy_pon[80];

    while ( --argc > 0 ) {
	p = *(++argv);
	if ( *p == '-' || *p == '/' ) {
	    switch(toupper(*(p+1))) {
	    case 'M': MP_FLG = TRUE; break;
	    }
	} else if ( eupfile == NULL )
	    eupfile = p;
	else
	    ponfile = p;
    }

    if ( eupfile == NULL ) {
	dsp_msg("use:RUN386 EupPon <EUP File Name> [<Pon File Name>] [/M]\n");
	dsp_msg("\n\t/M is Muisc Pro Towns BugFix Mode\n");
	exit(0);
    }

#ifdef	BASIC
    dsp_msg("Eup to BASIC Converter Version 1.00\n");
#else
    dsp_msg("Eup to Pon Converter Version 1.00\n");
#endif
    dsp_msg("Copyleft (c) 1990 Nifty TOWNS Forum YAMA&Ken\n\n");

    if ( (p = strrchr(eupfile,'\\')) == NULL )
	p = eupfile;
    if ( strrchr(p,'.') == NULL ) {
	sprintf(dmy_eup,"%s.EUP",eupfile);
	eupfile = dmy_eup;
    }

    if ( (fp = fopen(eupfile,"rb")) == NULL ) {
	dsp_msg("Can't open '%s'\n",eupfile);
        exit(1);
    }

    title[32] = '\0';
    fread(title,1,32,fp);

    fseek(fp,1748L,0);
    fread(part_ch,1,14,fp);

    fmfile[8] = pcmfile[8] = '\0';
    fseek(fp,1762L,0);
    fread(fmfile,1,8,fp);
    fseek(fp,1770L,0);
    fread(pcmfile,1,8,fp);

    fseek(fp,2048L,0);
    fread(&size,1,4,fp);
    fread(&signa,1,1,fp);
    fread(&tempo,1,1,fp);

    dsp_msg("Loading EUP Music Data\n");

    if ( size > MAX_BUF ) {
	size = MAX_BUF;
	dsp_msg("Can't Read All Eup Data...(Memory Full)\n");
    }
    fread(eup_buf,1,(int)size,fp);
    fclose(fp);

    btm_ptr = &eup_buf[size];
    fst_trk = (-1);

    dmy.next = NULL;
    for ( i = 0 ; i < MAX_TRK ; i++ ) {
        dsp_msg("\rNow Convert is No.%d",i);
        cnv_mml(eup_buf,&dmy,i);
    }
    dsp_msg(" End of Convert\n");

    if ( ponfile == NULL )
	fp = stdout;
    else {
	if ( (p = strrchr(ponfile,'\\')) == NULL )
	    p = ponfile;
	if ( strrchr(p,'.') == NULL ) {
#ifdef	BASIC
	    sprintf(dmy_pon,"%s.BAS",ponfile);
#else
	    sprintf(dmy_pon,"%s.PON",ponfile);
#endif
	    ponfile = dmy_pon;
	}
	if ( (fp = fopen(ponfile,"w")) == NULL ) {
	    dsp_msg("Can't Create '%s'\n",ponfile);
	    exit(1);
	}
    }

#ifdef  BASIC

/* Basic Format out ... */

    meas = no = 0;
    mml = dmy.next;

    fprintf(fp,"%d ' EUP to BASIC MML Format v1.00\n",(no += 10));
    fprintf(fp,"%d '\n",(no += 10));
    fprintf(fp,"%d ' EUP File Name is %s\n",(no += 10),eupfile);
    fprintf(fp,"%d '\n",(no += 10));
    fprintf(fp,"%d ' EUP File Title is %s\n",(no += 10),title);
    fprintf(fp,"%d '\n",(no += 10));

    fprintf(fp,"%d PLAY OFF\n",(no += 10));
    fprintf(fp,"%d LOAD@ \"%s.FMB\"\n",(no += 10),fmfile);
    fprintf(fp,"%d LOAD@ \"%s.PMB\"\n",(no += 10),pcmfile);

    for ( i = 0 ; i < 14 ; i++ )
        fprintf(fp,"%d PART %d,%d\n",(no += 10),i,part_ch[i]-1);

    while ( mml != NULL ) {
	if ( mml->next == NULL ) {
	    for ( i = 0 ; i < MAX_TRK && mml->part[i] == NULL ; i++ );
	    if ( i >= MAX_TRK )
		break;
	}

        fprintf(fp,"%d '*** %d ***\n",(no += 10),++meas);
        for ( i = 0 ; i < MAX_TRK ; i++ ) {
            fprintf(fp,"%d M%-d$=",(no += 10),i);
            fprintf(fp,"\"%s\"\n",mml->part[i] == NULL ? "":mml->part[i]);
        }
        fprintf(fp,"%d PLAY M0$,M1$,M2$,M3$,M4$,M5$,M6$,M7$,M8$,M9$,M10$,M11$,M12$,M13$,M14$,M15$\n",(no += 10));

        mml = mml->next;
    }

#else

/* Pon Format out ... */

    if ( (p = strrchr(eupfile,'\\')) != NULL )
        eupfile = p + 1;
    if ( (p = strrchr(eupfile,':')) != NULL )
        eupfile = p + 1;
    if ( (p = strrchr(eupfile,'.')) != NULL )
        *p = '\0';

    fprintf(fp,"*** Eup_de_Pon! v1.00 ***\n");

    fprintf(fp,"EupFile : %s\n",eupfile);
    fprintf(fp,"Title : %s\n",title);

    fprintf(fp,"Part :");
    for ( i = 0 ; i < 14 ; i++ )
        fprintf(fp," %d",part_ch[i]-1);
    fprintf(fp,"\n");

    fprintf(fp,"FmFile : %s\n",fmfile);
    fprintf(fp,"PcmFile : %s\n",pcmfile);
    fprintf(fp,"\n");

    meas = 0;
    mml = dmy.next;

    while ( mml != NULL ) {
	if ( mml->next == NULL ) {
	    for ( i = 0 ; i < MAX_TRK && mml->part[i] == NULL ; i++ );
	    if ( i >= MAX_TRK )
		break;
	}

        fprintf(fp,"data%d {\n",++meas);
        for ( i = 0 ; i < MAX_TRK ; i++ ) {
            if ( mml->part[i] != NULL )
                fprintf(fp,"\t%2d = %s\n",i,mml->part[i]);
        }
        fprintf(fp,"}\n");

        mml = mml->next;
    }

    fprintf(fp,"*** End_of_Pon! v1.00 ***\n");
#endif
}
